/*
 *  GuiLoader, a GuiXml loader library
 *  Copyright (c) 2006 Maxim Udushlivy
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include "containers.h"

// GideonChild -----------------------------------------------------------------

GType gideon_child_get_type(void) {
	static GType object_type= 0;
	if(object_type==0) {
		static const GTypeInfo object_info= {
			sizeof(GObjectClass), 
			NULL, NULL, NULL, NULL, NULL, 
			sizeof(GideonChild), 
			0, (GInstanceInitFunc)gideon_child_init,
		};
		object_type= g_type_register_static(G_TYPE_OBJECT, "GideonChild", &object_info, 0);
	}
	return object_type;
}

void gideon_child_init(GideonChild * child) {
	child->widget= NULL;
	child->place.a= 0;
	child->place.b= 0;
	child->place.c= 0;
	child->place.d= 0;
}

// GideonRowChild --------------------------------------------------------------

GType gideon_row_child_get_type(void) {
	static GType object_type= 0;
	if(object_type==0) {
		static const GTypeInfo object_info= {
			sizeof(GObjectClass), 
			NULL, NULL, NULL, NULL, NULL, 
			sizeof(GideonRowChild), 
			0, NULL,
		};
		object_type= g_type_register_static(GIDEON_TYPE_CHILD, "GideonRowChild", &object_info, 0);
	}
	return object_type;
}

// GideonXYChild ---------------------------------------------------------------

GType gideon_xy_child_get_type(void) {
	static GType object_type= 0;
	if(object_type==0) {
		static const GTypeInfo object_info= {
			sizeof(GObjectClass), 
			NULL, NULL, NULL, NULL, NULL, 
			sizeof(GideonXYChild), 
			0, NULL,
		};
		object_type= g_type_register_static(GIDEON_TYPE_CHILD, "GideonXYChild", &object_info, 0);
	}
	return object_type;
}

// GideonBoxChild --------------------------------------------------------------

GType gideon_box_child_get_type(void) {
	static GType object_type= 0;
	if(object_type==0) {
		static const GTypeInfo object_info= {
			sizeof(GObjectClass), 
			NULL, NULL, NULL, NULL, NULL, 
			sizeof(GideonBoxChild), 
			0, (GInstanceInitFunc)gideon_box_child_init,
		};
		object_type= g_type_register_static(GIDEON_TYPE_CHILD, "GideonBoxChild", &object_info, 0);
	}
	return object_type;
}

void gideon_box_child_init(GideonBoxChild * child) {
	GIDEON_CHILD(child)->place.b= GTK_PACK_START;
	child->options= GIDEON_PACK_EXPAND_WIDGET;
	child->padding= 0;
}

// GideonButtonBoxChild --------------------------------------------------------

GType gideon_button_box_child_get_type(void) {
	static GType object_type= 0;
	if(object_type==0) {
		static const GTypeInfo object_info= {
			sizeof(GObjectClass), 
			NULL, NULL, NULL, NULL, NULL, 
			sizeof(GideonButtonBoxChild), 
			0, (GInstanceInitFunc)gideon_button_box_child_init,
		};
		object_type= g_type_register_static(GIDEON_TYPE_BOX_CHILD, "GideonButtonBoxChild", &object_info, 0);
	}
	return object_type;
}

void gideon_button_box_child_init(GideonButtonBoxChild * child) {
	child->secondary= FALSE;
}

// GideonPanedChild ------------------------------------------------------------

GType gideon_paned_child_get_type(void) {
	static GType object_type= 0;
	if(object_type==0) {
		static const GTypeInfo object_info= {
			sizeof(GObjectClass), 
			NULL, NULL, NULL, NULL, NULL, 
			sizeof(GideonPanedChild), 
			0, (GInstanceInitFunc)gideon_paned_child_init,
		};
		object_type= g_type_register_static(GIDEON_TYPE_CHILD, "GideonPanedChild", &object_info, 0);
	}
	return object_type;
}

void gideon_paned_child_init(GideonPanedChild * child) {
	child->resize= TRUE;
	child->shrink= TRUE;
}

// GideonNotebookChild ---------------------------------------------------------

GType gideon_notebook_child_get_type(void) {
	static GType object_type= 0;
	if(object_type==0) {
		static const GTypeInfo object_info= {
			sizeof(GObjectClass), 
			NULL, NULL, NULL, NULL, NULL, 
			sizeof(GideonNotebookChild), 
			0, (GInstanceInitFunc)gideon_notebook_child_init,
		};
		object_type= g_type_register_static(GIDEON_TYPE_CHILD, "GideonNotebookChild", &object_info, 0);
	}
	return object_type;
}

void gideon_notebook_child_init(GideonNotebookChild * child) {
	child->tabLabel= NULL;
	child->tabLabelWidget= NULL;
	child->menuLabel= NULL;
	child->menuLabelWidget= NULL;
	child->packOptions= GIDEON_PACK_SHRINK;
}

// GideonTableChild ------------------------------------------------------------

GType gideon_table_child_get_type(void) {
	static GType object_type= 0;
	if(object_type==0) {
		static const GTypeInfo object_info= {
			sizeof(GObjectClass), 
			NULL, NULL, NULL, NULL, NULL, 
			sizeof(GideonTableChild), 
			0, (GInstanceInitFunc)gideon_table_child_init,
		};
		object_type= g_type_register_static(GIDEON_TYPE_CHILD, "GideonTableChild", &object_info, 0);
	}
	return object_type;
}

void gideon_table_child_init(GideonTableChild * child) {
	GIDEON_CHILD(child)->place.c= 1;
	GIDEON_CHILD(child)->place.d= 1;
	child->paddingX= 0;
	child->paddingY= 0;
	child->xExpand= TRUE;
	child->xFill= TRUE;
	child->xShrink= FALSE;
	child->yExpand= TRUE;
	child->yFill= TRUE;
	child->yShrink= FALSE;
}

// -----------------------------------------------------------------------------

gboolean ContainerIsEmpty(GtkContainer * container) {
	return gtk_container_get_children(container) == NULL;
}

gboolean GetExpand(GideonPackOptions packOptions) {
	return packOptions != GIDEON_PACK_SHRINK;
}

gboolean GetFill(GideonPackOptions packOptions) {
	return packOptions == GIDEON_PACK_EXPAND_WIDGET;
}

GtkAttachOptions GetAttachOptions(gboolean expand, gboolean fill, gboolean shrink) {
	GtkAttachOptions result= 0;
	if(expand)
		result |= GTK_EXPAND;
	if(fill)
		result |= GTK_FILL;
	if(shrink)
		result |= GTK_SHRINK;
	return result;
}

GtkWidget * CreatePlaceholder(void) {
	GtkWidget * widget= gtk_drawing_area_new();
	gtk_widget_set_size_request(widget, 40, 40);
	g_signal_connect(G_OBJECT(widget), "expose-event", G_CALLBACK(ExposePlaceholder), NULL);
	gtk_widget_show(widget);
	return widget;
}

gboolean ExposePlaceholder(GtkWidget * widget, GdkEventExpose * event, gpointer data) {
	GdkDrawable * window= GDK_DRAWABLE(widget->window);
	GdkGC * gc= gdk_gc_new(window);
	int W, H, GS, GW, GH, xx, yy, GX, GY, x, y;
	gdk_drawable_get_size(window, &W, &H);
	GS= 9;
	GW= W-4;
	GH= H-4;
	xx= GW/GS;
	yy= GH/GS;
	GX= 2 + (GW-xx*GS)/2;
	GY= 2 + (GH-yy*GS)/2;
	gdk_gc_set_foreground(gc, &widget->style->dark[GTK_STATE_NORMAL]);
	gdk_draw_rectangle(window, gc, FALSE, 1, 1, W-3, H-3);
	for(x=0; x<xx; ++x)
		for(y=0; y<yy; ++y)
			gdk_draw_point(window, gc, GX+x*GS+GS/2, GY+y*GS+GS/2);
  return TRUE;
}

void ContainerFixedSet(GtkFixed * fixed, PtrArray * children) {
	int i;
	for(i= 0; i < children->size; ++i) {
		GideonChild * child= GIDEON_CHILD(children->ptrs[i]);
		gtk_fixed_put(fixed, child->widget, child->place.a, child->place.b);
	}
}

void ContainerLayoutSet(GtkLayout * layout, PtrArray * children) {
	int i;
	for(i= 0; i < children->size; ++i) {
		GideonChild * child= GIDEON_CHILD(children->ptrs[i]);
		gtk_layout_put(layout, child->widget, child->place.a, child->place.b);
	}
}

void ContainerBinSet(GtkBin * bin, PtrArray * children) {
	GideonChild * child;
	Check(children && children->size==1);
	child= GIDEON_CHILD(children->ptrs[0]);
	gtk_container_add(GTK_CONTAINER(bin), child->widget);
}

void ContainerScrolledWindowSet(GtkScrolledWindow * scroll, PtrArray * children) {
	GideonChild * child;
	Check(children && children->size==1);
	child= GIDEON_CHILD(children->ptrs[0]);
	if(GTK_WIDGET_GET_CLASS(child->widget)->set_scroll_adjustments_signal != 0)
		gtk_container_add(GTK_CONTAINER(scroll), child->widget);
	else {
		GtkViewport * viewport;
		gtk_scrolled_window_add_with_viewport(scroll, child->widget);
		viewport= GTK_VIEWPORT(gtk_bin_get_child(GTK_BIN(scroll)));
		g_object_set_data(G_OBJECT(viewport), "GideonAutoViewportHint", "true");
	}
}

void ContainerDialogSet(GtkDialog * dialog, PtrArray * children) {
	GideonChild * child;
	GtkBox * box;
	Check(children && children->size==1);
	child= GIDEON_CHILD(children->ptrs[0]);
	box= GTK_BOX(dialog->vbox); 
	gtk_box_pack_start_defaults(box, child->widget);
}

void ContainerPanedSet(GtkPaned * paned, PtrArray * children) {
	int i;
	Check(children && children->size <= 2);
	for(i= 0; i < children->size; ++i) {
		GideonPanedChild * child= GIDEON_PANED_CHILD(children->ptrs[i]);
		if(GIDEON_CHILD(child)->place.a==0)
			gtk_paned_pack1(paned, GIDEON_CHILD(child)->widget, child->resize, child->shrink);
		else {
			Check(GIDEON_CHILD(child)->place.a==1);
			gtk_paned_pack2(paned, GIDEON_CHILD(child)->widget, child->resize, child->shrink);
		}
	}
}

void ContainerBoxSet(GtkBox * box, PtrArray * children, int capS, int capE) {
	PGideonChild * sorted= g_slice_alloc0(sizeof(gpointer)*(capS+capE));

	int i;
	if(children)
		for(i= 0; i < children->size; ++i) {
			GideonChild * child= GIDEON_CHILD(children->ptrs[i]);
			if(child->place.b == GTK_PACK_START) {
				Check(child->place.a < capS);
				Check(!sorted[child->place.a]);
				sorted[child->place.a]= child;
			} else {
				Check(child->place.b == GTK_PACK_END);
				Check(child->place.a < capE);
				Check(!sorted[capS + child->place.a]);
				sorted[capS + child->place.a]= child;
			}
		}

	for(i=0; i<capS+capE; ++i) {
		GideonChild * child= sorted[i];
		GideonBoxChild * boxChild;
		
		if(!child) {
			child= g_object_new(GIDEON_TYPE_BOX_CHILD, NULL);
			if(i<capS) {
				child->place.a= i;
				child->place.b= GTK_PACK_START;
			} else {
				child->place.a= i-capS;
				child->place.b= GTK_PACK_END;
			}
			child->widget= CreatePlaceholder();
		}

		boxChild= GIDEON_BOX_CHILD(child);
		if(child->place.b == GTK_PACK_START)
			gtk_box_pack_start(box, child->widget, GetExpand(boxChild->options), GetFill(boxChild->options), boxChild->padding);
		else
			gtk_box_pack_end(box, child->widget, GetExpand(boxChild->options), GetFill(boxChild->options), boxChild->padding);

		if(!sorted[i])
			g_object_unref(child);
		
	}
	
	g_slice_free1(sizeof(gpointer)*(capS+capE), sorted);	
}

void ContainerButtonBoxSet(GtkButtonBox * box, PtrArray * children, int capS, int capE) {
	int i;
	ContainerBoxSet(GTK_BOX(box), children, capS, capE);
	if(children)
		for(i= 0; i < children->size; ++i) {
			GideonButtonBoxChild * child= GIDEON_BUTTON_BOX_CHILD(children->ptrs[i]);
			if(child->secondary)
				gtk_button_box_set_child_secondary(box, GIDEON_CHILD(child)->widget, TRUE);
		}
}

void ContainerNotebookSet(GtkNotebook * notebook, PtrArray * children, int capacity) {
	PGideonChild * sorted= g_slice_alloc0(sizeof(gpointer)*capacity);

	int i;
	if(children)
		for(i= 0; i < children->size; ++i) {
			GideonChild * child= GIDEON_CHILD(children->ptrs[i]);
			Check(child->place.a < capacity);
			Check(!sorted[child->place.a]);
			sorted[child->place.a]= child;
		}

	for(i=0; i<capacity; ++i) {
		GideonChild * child= sorted[i];
		GideonNotebookChild * nbChild;
		
		if(!child) {
			child= g_object_new(GIDEON_TYPE_NOTEBOOK_CHILD, NULL);
			child->place.a= i;
			child->widget= CreatePlaceholder();
		}

		nbChild= GIDEON_NOTEBOOK_CHILD(child);
		gtk_notebook_append_page(notebook, child->widget, nbChild->tabLabelWidget);
		if(!nbChild->tabLabelWidget) {
			if(nbChild->tabLabel)
				gtk_notebook_set_tab_label_text(notebook, child->widget, nbChild->tabLabel);
			else {
				gchar tabLabel[256];
				g_snprintf(tabLabel, sizeof(tabLabel), "Page %d", i);
				gtk_notebook_set_tab_label_text(notebook, child->widget, tabLabel);
			}
		}
		if(nbChild->menuLabelWidget) {
			gtk_notebook_set_menu_label(notebook, child->widget, nbChild->menuLabelWidget);
		} else {
			if(nbChild->menuLabel)
				gtk_notebook_set_menu_label_text(notebook, child->widget, nbChild->menuLabel);
		}
		gtk_notebook_set_tab_label_packing(notebook, child->widget, GetExpand(nbChild->packOptions), GetFill(nbChild->packOptions), GTK_PACK_START);

		if(!sorted[i])
			g_object_unref(child);
		
	}

	g_slice_free1(sizeof(gpointer)*capacity, sorted);	
}

void ContainerTableSet(GtkTable * table, PtrArray * children, int capX, int capY) {
	int i;
	gtk_table_resize(table, capX, capY);
	if(children)
		for(i= 0; i < children->size; ++i) {
			GideonChild * child= GIDEON_CHILD(children->ptrs[i]);
			GideonTableChild * tblChild= GIDEON_TABLE_CHILD(children->ptrs[i]);
			gtk_table_attach(
				table, child->widget,
				child->place.a, child->place.a + child->place.c,
				child->place.b, child->place.b + child->place.d,
				GetAttachOptions(tblChild->xExpand, tblChild->xFill, tblChild->xShrink),
				GetAttachOptions(tblChild->yExpand, tblChild->yFill, tblChild->yShrink),
				tblChild->paddingX, tblChild->paddingY
			);
		}
}
