/*
 *  GuiLoader, a GuiXml loader library
 *  Copyright (c) 2006 Maxim Udushlivy
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

#ifndef GUILOADER_CONTAINERS_H
#define GUILOADER_CONTAINERS_H

#include "guiloader_impl.h"

typedef struct _Place Place;

struct _Place {
	int a, b, c, d;
};

// GideonChild -----------------------------------------------------------------

#define GIDEON_TYPE_CHILD (gideon_child_get_type())
#define GIDEON_CHILD(obj) (G_TYPE_CHECK_INSTANCE_CAST((obj), GIDEON_TYPE_CHILD, GideonChild))
#define GIDEON_IS_CHILD(obj) (G_TYPE_CHECK_INSTANCE_TYPE((obj), GIDEON_TYPE_CHILD))

typedef struct _GideonChild GideonChild;

struct _GideonChild {
	GObject parent;
	GtkWidget * widget;
	Place place;
};

GType gideon_child_get_type(void);
void gideon_child_init(GideonChild * child);

// GideonRowChild --------------------------------------------------------------

#define GIDEON_TYPE_ROW_CHILD (gideon_row_child_get_type())
#define GIDEON_ROW_CHILD(obj) (G_TYPE_CHECK_INSTANCE_CAST((obj), GIDEON_TYPE_ROW_CHILD, GideonRowChild))
#define GIDEON_IS_ROW_CHILD(obj) (G_TYPE_CHECK_INSTANCE_TYPE((obj), GIDEON_TYPE_ROW_CHILD))

typedef struct _GideonChild GideonRowChild;

GType gideon_row_child_get_type(void);

// GideonXYChild ---------------------------------------------------------------

#define GIDEON_TYPE_XY_CHILD (gideon_xy_child_get_type())
#define GIDEON_XY_CHILD(obj) (G_TYPE_CHECK_INSTANCE_CAST((obj), GIDEON_TYPE_XY_CHILD, GideonXYChild))
#define GIDEON_IS_XY_CHILD(obj) (G_TYPE_CHECK_INSTANCE_TYPE((obj), GIDEON_TYPE_XY_CHILD))

typedef struct _GideonChild GideonXYChild;

GType gideon_xy_child_get_type(void);

// GideonBoxChild --------------------------------------------------------------

#define GIDEON_TYPE_BOX_CHILD (gideon_box_child_get_type())
#define GIDEON_BOX_CHILD(obj) (G_TYPE_CHECK_INSTANCE_CAST((obj), GIDEON_TYPE_BOX_CHILD, GideonBoxChild))
#define GIDEON_IS_BOX_CHILD(obj) (G_TYPE_CHECK_INSTANCE_TYPE((obj), GIDEON_TYPE_BOX_CHILD))

typedef struct _GideonBoxChild GideonBoxChild;

struct _GideonBoxChild {
	GideonChild parent;
	GideonPackOptions options;
	unsigned padding;
};

GType gideon_box_child_get_type(void);
void gideon_box_child_init(GideonBoxChild * child);

// GideonButtonBoxChild --------------------------------------------------------

#define GIDEON_TYPE_BUTTON_BOX_CHILD (gideon_button_box_child_get_type())
#define GIDEON_BUTTON_BOX_CHILD(obj) (G_TYPE_CHECK_INSTANCE_CAST((obj), GIDEON_TYPE_BUTTON_BOX_CHILD, GideonButtonBoxChild))
#define GIDEON_IS_BUTTON_BOX_CHILD(obj) (G_TYPE_CHECK_INSTANCE_TYPE((obj), GIDEON_TYPE_BUTTON_BOX_CHILD))

typedef struct _GideonButtonBoxChild GideonButtonBoxChild;

struct _GideonButtonBoxChild {
	GideonBoxChild parent;
	gboolean secondary;
};

GType gideon_button_box_child_get_type(void);
void gideon_button_box_child_init(GideonButtonBoxChild * child);

// GideonPanedChild ------------------------------------------------------------

#define GIDEON_TYPE_PANED_CHILD (gideon_paned_child_get_type())
#define GIDEON_PANED_CHILD(obj) (G_TYPE_CHECK_INSTANCE_CAST((obj), GIDEON_TYPE_PANED_CHILD, GideonPanedChild))
#define GIDEON_IS_PANED_CHILD(obj) (G_TYPE_CHECK_INSTANCE_TYPE((obj), GIDEON_TYPE_PANED_CHILD))

typedef struct _GideonPanedChild GideonPanedChild;

struct _GideonPanedChild {
	GideonChild parent;
	gboolean resize;
	gboolean shrink;
};

GType gideon_paned_child_get_type(void);
void gideon_paned_child_init(GideonPanedChild * child);

// GideonNotebookChild ---------------------------------------------------------

#define GIDEON_TYPE_NOTEBOOK_CHILD (gideon_notebook_child_get_type())
#define GIDEON_NOTEBOOK_CHILD(obj) (G_TYPE_CHECK_INSTANCE_CAST((obj), GIDEON_TYPE_NOTEBOOK_CHILD, GideonNotebookChild))
#define GIDEON_IS_NOTEBOOK_CHILD(obj) (G_TYPE_CHECK_INSTANCE_TYPE((obj), GIDEON_TYPE_NOTEBOOK_CHILD))

typedef struct _GideonNotebookChild GideonNotebookChild;

struct _GideonNotebookChild {
	GideonChild parent;
	const gchar * tabLabel;
	GtkWidget * tabLabelWidget;
	const gchar * menuLabel;
	GtkWidget * menuLabelWidget;
	GideonPackOptions packOptions;
};

GType gideon_notebook_child_get_type(void);
void gideon_notebook_child_init(GideonNotebookChild * child);

// GideonTableChild ------------------------------------------------------------

#define GIDEON_TYPE_TABLE_CHILD (gideon_table_child_get_type())
#define GIDEON_TABLE_CHILD(obj) (G_TYPE_CHECK_INSTANCE_CAST((obj), GIDEON_TYPE_TABLE_CHILD, GideonTableChild))
#define GIDEON_IS_TABLE_CHILD(obj) (G_TYPE_CHECK_INSTANCE_TYPE((obj), GIDEON_TYPE_TABLE_CHILD))

typedef struct _GideonTableChild GideonTableChild;

struct _GideonTableChild {
	GideonChild parent;
	unsigned paddingX;
	unsigned paddingY;
	gboolean xExpand;
	gboolean xFill;
	gboolean xShrink;
	gboolean yExpand;
	gboolean yFill;
	gboolean yShrink;
};

GType gideon_table_child_get_type(void);
void gideon_table_child_init(GideonTableChild * child);

// -----------------------------------------------------------------------------

typedef GideonChild * PGideonChild;

gboolean ContainerIsEmpty(GtkContainer * container);

gboolean GetExpand(GideonPackOptions packOptions);
gboolean GetFill(GideonPackOptions packOptions);
GtkAttachOptions GetAttachOptions(gboolean expand, gboolean fill, gboolean shrink);

GtkWidget * CreatePlaceholder(void);
gboolean ExposePlaceholder(GtkWidget * widget, GdkEventExpose * event, gpointer data);

void ContainerFixedSet(GtkFixed * fixed, PtrArray * children);
void ContainerLayoutSet(GtkLayout * layout, PtrArray * children);
void ContainerBinSet(GtkBin * bin, PtrArray * children);
void ContainerScrolledWindowSet(GtkScrolledWindow * scroll, PtrArray * children);
void ContainerDialogSet(GtkDialog * dialog, PtrArray * children);
void ContainerPanedSet(GtkPaned * paned, PtrArray * children);
void ContainerBoxSet(GtkBox * box, PtrArray * children, int capS, int capE);
void ContainerButtonBoxSet(GtkButtonBox * box, PtrArray * children, int capS, int capE);
void ContainerNotebookSet(GtkNotebook * notebook, PtrArray * children, int cap);
void ContainerTableSet(GtkTable * table, PtrArray * children, int capX, int capY);

#endif
