/*
 *  GuiLoader, a GuiXml loader library
 *  Copyright (c) 2006 Maxim Udushlivy
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include "proxies.h"
#include "containers.h"

void RegisterProxies(GuiLoaderInit * init) {

	RegisterGType(GDK_TYPE_EVENT_MASK);
	RegisterGType(GDK_TYPE_EXTENSION_MODE);
	RegisterGType(GTK_TYPE_SHADOW_TYPE);
	RegisterGType(GTK_TYPE_POLICY_TYPE);
	RegisterGType(GTK_TYPE_CORNER_TYPE);
	RegisterGType(GTK_TYPE_POSITION_TYPE);
	RegisterGType(GTK_TYPE_BUTTON_BOX_STYLE);
	RegisterGType(GDK_TYPE_GRAVITY);
	RegisterGType(GTK_TYPE_WINDOW_TYPE);
	RegisterGType(GDK_TYPE_WINDOW_TYPE_HINT);
	RegisterGType(GTK_TYPE_WINDOW_POSITION);
	RegisterGType(GTK_TYPE_ORIENTATION);
	RegisterGType(GTK_TYPE_TOOLBAR_STYLE);
	RegisterGType(GTK_TYPE_RESPONSE_TYPE);
	RegisterGType(GTK_TYPE_FILE_CHOOSER_ACTION);
	RegisterGType(GTK_TYPE_PACK_DIRECTION);
	RegisterGType(PANGO_TYPE_ELLIPSIZE_MODE);
	RegisterGType(GTK_TYPE_JUSTIFICATION);
	RegisterGType(GTK_TYPE_RELIEF_STYLE);
	RegisterGType(GTK_TYPE_SPIN_BUTTON_UPDATE_POLICY);
	RegisterGType(GTK_TYPE_UPDATE_TYPE);
	RegisterGType(GTK_TYPE_PROGRESS_BAR_ORIENTATION);
	RegisterGType(GTK_TYPE_ICON_SIZE);
	RegisterGType(GTK_TYPE_SIZE_GROUP_MODE);
	RegisterGType(GTK_TYPE_WRAP_MODE);
	RegisterGType(GTK_TYPE_SELECTION_MODE);
	RegisterGType(GTK_TYPE_ARROW_TYPE);

	AddProxy(init, GIDEON_TYPE_ROW_CHILD, GideonChildProxy, 0);
	AddProxy(init, GTK_TYPE_ALIGNMENT, GtkAlignmentProxy, 0); 
	AddProxy(init, GTK_TYPE_FRAME, GtkFrameProxy, 0); 
	AddProxy(init, GTK_TYPE_ASPECT_FRAME, GtkAspectFrameProxy, 0); 
	AddProxy(init, GTK_TYPE_EXPANDER, GtkExpanderProxy, 0);
	AddProxy(init, GTK_TYPE_SCROLLED_WINDOW, GtkScrolledWindowProxy, 0);
	AddProxy(init, GTK_TYPE_HANDLE_BOX, GtkHandleBoxProxy, 0);
	AddProxy(init, GTK_TYPE_VIEWPORT, GtkViewportProxy, 0);
	AddProxy(init, GIDEON_TYPE_BOX_CHILD, GideonBoxChildProxy, 0);
	AddProxy(init, GTK_TYPE_HBOX, GtkBoxProxy, 0);
	AddProxy(init, GTK_TYPE_VBOX, GtkBoxProxy, 0);
	AddProxy(init, GIDEON_TYPE_BUTTON_BOX_CHILD, GideonButtonBoxChildProxy, 0);
	AddProxy(init, GTK_TYPE_HBUTTON_BOX, GtkButtonBoxProxy, 0);
	AddProxy(init, GTK_TYPE_VBUTTON_BOX, GtkButtonBoxProxy, 0);
	AddProxy(init, GIDEON_TYPE_PANED_CHILD, GideonPanedChildProxy, 0);
	AddProxy(init, GTK_TYPE_HPANED, GtkPanedProxy, 0);
	AddProxy(init, GTK_TYPE_VPANED, GtkPanedProxy, 0);
	AddProxy(init, GIDEON_TYPE_NOTEBOOK_CHILD, GideonNotebookChildProxy, 0);
	AddProxy(init, GTK_TYPE_NOTEBOOK, GtkNotebookProxy, 0);
	AddProxy(init, GIDEON_TYPE_TABLE_CHILD, GideonTableChildProxy, 0);
	AddProxy(init, GTK_TYPE_TABLE, GtkTableProxy, 0);
	AddProxy(init, GIDEON_TYPE_XY_CHILD, GideonXYChildProxy, 0);
	AddProxy(init, GTK_TYPE_ADJUSTMENT, GtkAdjustmentProxy, 0);
	AddProxy(init, GTK_TYPE_WINDOW, GtkWindowProxy, 0);
	AddProxy(init, GIDEON_TYPE_DIALOG_BUTTON_ENTRY, GideonDialogButtonEntryProxy, 0);
	AddProxy(init, GTK_TYPE_DIALOG, GtkDialogProxy, 0);
	AddProxy(init, GTK_TYPE_COLOR_SELECTION_DIALOG, GtkColorSelectionDialogProxy, 0);
	AddProxy(init, GTK_TYPE_FILE_FILTER, GtkFileFilterProxy, 0);
	AddProxy(init, GTK_TYPE_FILE_CHOOSER_DIALOG, GtkFileChooserDialogProxy, 0);
	AddProxy(init, GTK_TYPE_FONT_SELECTION_DIALOG, GtkFontSelectionDialogProxy, 0);	
	AddProxy(init, GTK_TYPE_MENU_BAR, GtkMenuBarProxy, 0);
	AddProxy(init, GTK_TYPE_TOOLBAR, GtkToolbarProxy, 0);
	AddProxy(init, GTK_TYPE_STATUSBAR, GtkStatusbarProxy, 0);
	AddProxy(init, GIDEON_TYPE_TOOLTIPS_ENTRY, GideonTooltipsEntryProxy, 0);
	AddProxy(init, GTK_TYPE_TOOLTIPS, GtkTooltipsProxy, 1);
	AddProxy(init, GTK_TYPE_ACTION_GROUP, GtkActionGroupProxy, -2);
	AddProxy(init, GTK_TYPE_ACTION, GtkActionProxy, 0);
	AddProxy(init, GTK_TYPE_TOGGLE_ACTION, GtkToggleActionProxy, 0);
	AddProxy(init, GTK_TYPE_RADIO_ACTION, GtkRadioActionProxy, 0);
	AddProxy(init, GTK_TYPE_UI_MANAGER, GtkUIManagerProxy, -1);
	AddProxy(init, GIDEON_TYPE_UI_DEFINITION, GideonUIDefinitionProxy, -2);
	AddProxy(init, GIDEON_TYPE_RADIO_GROUP, GideonRadioGroupProxy, -3);
	AddProxy(init, GTK_TYPE_LABEL, GtkLabelProxy, 0);
	AddProxy(init, GTK_TYPE_BUTTON, GtkButtonProxy, 0);
	AddProxy(init, GTK_TYPE_TOGGLE_BUTTON, GtkToggleButtonProxy, 0);
	AddProxy(init, GTK_TYPE_CHECK_BUTTON, GtkCheckButtonProxy, 0);
	AddProxy(init, GTK_TYPE_RADIO_BUTTON, GtkRadioButtonProxy, 0);
	AddProxy(init, GTK_TYPE_ENTRY_COMPLETION, GtkEntryCompletionProxy, 0);
	AddProxy(init, GTK_TYPE_ENTRY, GtkEntryProxy, 0);
	AddProxy(init, GTK_TYPE_COMBO_BOX, GtkComboBoxProxy, 0);
	AddProxy(init, GTK_TYPE_COMBO_BOX_ENTRY, GtkComboBoxEntryProxy, 0);
	AddProxy(init, GTK_TYPE_SPIN_BUTTON, GtkSpinButtonProxy, 0);
	AddProxy(init, GTK_TYPE_HSCALE, GtkScaleProxy, 0);
	AddProxy(init, GTK_TYPE_VSCALE, GtkScaleProxy, 0);
	AddProxy(init, GTK_TYPE_PROGRESS_BAR, GtkProgressBarProxy, 0);
	AddProxy(init, GTK_TYPE_IMAGE, GtkImageProxy, 0);
	AddProxy(init, GTK_TYPE_HSEPARATOR, GtkSeparatorProxy, 0);
	AddProxy(init, GTK_TYPE_VSEPARATOR, GtkSeparatorProxy, 0);
	AddProxy(init, GTK_TYPE_SIZE_GROUP, GtkSizeGroupProxy, 1);
	AddProxy(init, GTK_TYPE_TEXT_VIEW, GtkTextViewProxy, 0);
	AddProxy(init, GTK_TYPE_ICON_VIEW, GtkIconViewProxy, 0);
	AddProxy(init, GTK_TYPE_CELL_VIEW, GtkCellViewProxy, 0);
	AddProxy(init, GTK_TYPE_TREE_VIEW, GtkTreeViewProxy, 0);
	AddProxy(init, GTK_TYPE_COLOR_BUTTON, GtkColorButtonProxy, 0);
	AddProxy(init, GTK_TYPE_COLOR_SELECTION, GtkColorSelectionProxy, 0);
	AddProxy(init, GTK_TYPE_FILE_CHOOSER_BUTTON, GtkFileChooserButtonProxy, 0);
	AddProxy(init, GTK_TYPE_FILE_CHOOSER_WIDGET, GtkFileChooserWidgetProxy, 0);
	AddProxy(init, GTK_TYPE_FONT_BUTTON, GtkFontButtonProxy, 0);
	AddProxy(init, GTK_TYPE_FONT_SELECTION, GtkFontSelectionProxy, 0);
	AddProxy(init, GTK_TYPE_FIXED, GtkFixedProxy, 0);
	AddProxy(init, GTK_TYPE_LAYOUT, GtkLayoutProxy, 0);
	AddProxy(init, GTK_TYPE_HSCROLLBAR, GtkScrollbarProxy, 0);
	AddProxy(init, GTK_TYPE_VSCROLLBAR, GtkScrollbarProxy, 0);
	AddProxy(init, GTK_TYPE_EVENT_BOX, GtkEventBoxProxy, 0);
	AddProxy(init, GTK_TYPE_DRAWING_AREA, GtkDrawingAreaProxy, 0);
	AddProxy(init, GTK_TYPE_CALENDAR, GtkCalendarProxy, 0);
	AddProxy(init, GTK_TYPE_ARROW, GtkArrowProxy, 0);
}

void RegisterGType(GType type) {
	Check(type);
}

// GObjectProxy ----------------------------------------------------------------

void GObjectProxy(Proxy * proxy) {
	GUILOADER_VIRTUAL_BASE(proxy, vbGObject);
	AddProperty(proxy, "signals", PropertyGObjectSignals);
}

void PropertyGObjectSignals(PropertyFuncData * data) {
	PtrArray * array= ModelGetEmitterVector(data->node);
	int i;
	for(i= 0; i < array->size; ++i) {
		GideonEmitter * emitter= array->ptrs[i];
		AddConnector(data->loader, data->object, emitter);
	}
	PtrArrayFree(array);
}

// GtkWidget -------------------------------------------------------------------

void GtkWidgetProxy(Proxy * proxy) {
	GUILOADER_VIRTUAL_BASE(proxy, vbGtkWidget);
	GObjectProxy(proxy);
	AddInitInstance(proxy, GtkWidgetInit);
	AddProperty(proxy, "size-request", PropertyGtkWidgetSizeRequest);
	AddProperty(proxy, "sensitive", PropertyBool);
	AddProperty(proxy, "visible", PropertyBool);
}

void GtkWidgetInit(GObject * object, Node * node) {
	GtkWidget * widget= GTK_WIDGET(object);
	gtk_widget_set_name(widget, ShortStrGetStr(node->name));
	if(!GTK_IS_WINDOW(object))
		gtk_widget_show(widget);
}

void PropertyGtkWidgetSizeRequest(PropertyFuncData * data) {
	GideonPoint p= ModelGetPoint(data->node);
	gtk_widget_set_size_request(GTK_WIDGET(data->object), p.x, p.y);
}

void PropertyGtkWidgetEvents(PropertyFuncData * data) {
	gchar * endptr, * str;
	guint v;
	CheckNodeScalar(data->node);
	str= ShortStrGetStr(data->node->text);
	v= strtoul(str, &endptr, 16);
	Check(*str!=0 && *endptr==0);
	gtk_widget_add_events(GTK_WIDGET(data->object), v);
}

void GtkWidgetAddReceivesDefaultProperty(Proxy * proxy) {
	AddProperty(proxy, "receives-default", PropertyBool);
}

void GtkWidgetAddCanFocusProperty(Proxy * proxy) {
	AddProperty(proxy, "can-focus", PropertyBool);
}

void GtkWidgetAddCanDefaultProperty(Proxy * proxy) {
	AddProperty(proxy, "can-default", PropertyBool);
}

void GtkWidgetAddAppPaintableProperty(Proxy * proxy) {
	AddProperty(proxy, "app-paintable", PropertyBool);
}

void GtkWidgetAddEventProperties(Proxy * proxy) {
	AddProperty(proxy, "events", PropertyGtkWidgetEvents);
	AddProperty(proxy, "extension-events", PropertyEnum);
}

// GtkContainerProxyBase -------------------------------------------------------

void GtkContainerProxyBase(Proxy * proxy) {
	GtkWidgetProxy(proxy);
	AddProperty(proxy, "border-width", PropertyUnsigned);
}

// GtkContainerProxy -----------------------------------------------------------

void GtkContainerProxy(Proxy * proxy) {
	GUILOADER_VIRTUAL_BASE(proxy, vbGtkContainer);
	GtkContainerProxyBase(proxy);
	AddProperty(proxy, "children", NULL);
	AddProperty(proxy, "focus-chain", PropertyGtkContainerFocusChain);
	AddProperty(proxy, "focus-child", PropertyGtkContainerFocusChild);
}

void GtkContainerSetChildrenPropertyFunc(Proxy * proxy, PropertyFunc func) {
	Property * prop= FindProperty(proxy, "children");
	prop->assign= func;
}

void PropertyGtkContainerFocusChain(PropertyFuncData * data) {
	PtrArray * array= ModelGetObjectVector(data->loader, data->node);
	GList * chain= CreateListFromPtrArray(array);
	gtk_container_set_focus_chain(GTK_CONTAINER(data->object), chain);
	g_list_free(chain);
	PtrArrayFree(array);
}

void PropertyGtkContainerFocusChild(PropertyFuncData * data) {
	GObject * widget= ModelGetObject(data->loader, data->node, NULL);
	gtk_container_set_focus_child(GTK_CONTAINER(data->object), GTK_WIDGET(widget));
}

// GideonChildProxy ------------------------------------------------------------

void GideonChildProxy(Proxy * proxy) {
	GObjectProxy(proxy);
	AddProperty(proxy, "widget", PropertyGideonChildWidget);
}

void PropertyGideonChildWidget(PropertyFuncData * data) {
	GObject * widget= ModelGetObject(data->loader, data->node, NULL);
	GIDEON_CHILD(data->object)->widget= GTK_WIDGET(widget);
}

void GideonChildAddIndexProperty(Proxy * proxy) {
	AddProperty(proxy, "index", PropertyGideonChildIndex);
}

void PropertyGideonChildIndex(PropertyFuncData * data) {
	int value= ModelGetInt(data->node);
	GIDEON_CHILD(data->object)->place.a= value;
}

// GtkBinProxy -----------------------------------------------------------------

void GtkBinProxy(Proxy * proxy) {
	GtkContainerProxy(proxy);
	GtkContainerSetChildrenPropertyFunc(proxy, PropertyGtkBinChildren);
}

void PropertyGtkBinChildren(PropertyFuncData * data) {
	PtrArray * children;
	CheckNodeVector(data->node);
	children= ModelGetObjectVector(data->loader, data->node);
	ContainerBinSet(GTK_BIN(data->object), children);
	FreeObjectVector(children);
}

// GtkAlignmentProxy -----------------------------------------------------------

void GtkAlignmentProxy(Proxy * proxy) {
	GtkBinProxy(proxy);
	AddProperty(proxy, "bottom-padding", PropertyUnsigned);
	AddProperty(proxy, "left-padding", PropertyUnsigned);
	AddProperty(proxy, "right-padding", PropertyUnsigned);
	AddProperty(proxy, "top-padding", PropertyUnsigned);
	AddProperty(proxy, "xalign", PropertyFloat);
	AddProperty(proxy, "xscale", PropertyFloat);
	AddProperty(proxy, "yalign", PropertyFloat);
	AddProperty(proxy, "yscale", PropertyFloat);
}

// GtkFrameProxy ---------------------------------------------------------------

void GtkFrameProxy(Proxy * proxy) {
	GtkBinProxy(proxy);
	AddProperty(proxy, "label-widget-set", PropertyGtkFrameLabelWidgetSet);
	AddProperty(proxy, "label", PropertyGtkFrameLabel);
	AddProperty(proxy, "label-widget", PropertyObject);
	AddProperty(proxy, "label-xalign", PropertyFloat);
	AddProperty(proxy, "label-yalign", PropertyFloat);
	AddProperty(proxy, "shadow-type", PropertyEnum);
}

void PropertyGtkFrameLabelWidgetSet(PropertyFuncData * data) {
	gboolean set= ModelGetBool(data->node);
	if(!set)
		gtk_frame_set_label(GTK_FRAME(data->object), "");
}

void PropertyGtkFrameLabel(PropertyFuncData * data) {
	const gchar * str= ModelGetString(data->node);
	GtkWidget * widget= gtk_frame_get_label_widget(GTK_FRAME(data->object)); 
	Check(GTK_IS_LABEL(widget));
	gtk_label_set_label(GTK_LABEL(widget), str);
}

// GtkAspectFrameProxy ---------------------------------------------------------

void GtkAspectFrameProxy(Proxy * proxy) {
	GtkFrameProxy(proxy);
	AddInitInstance(proxy, GtkAspectFrameInit);
	AddProperty(proxy, "obey-child", PropertyBool);
	AddProperty(proxy, "ratio", PropertyFloat);
	AddProperty(proxy, "xalign", PropertyFloat);
	AddProperty(proxy, "yalign", PropertyFloat);
}

void GtkAspectFrameInit(GObject * object, Node * node) {
	gtk_aspect_frame_set(GTK_ASPECT_FRAME(object), 0.5f, 0.5f, 0.5f, TRUE);
}

// GtkExpanderProxy ------------------------------------------------------------

void GtkExpanderProxy(Proxy * proxy) {
	GtkBinProxy(proxy);
	AddInitInstance(proxy, GtkExpanderInit);
	GtkWidgetAddCanFocusProperty(proxy);
	AddProperty(proxy, "label", PropertyGtkExpanderLabel);
	AddProperty(proxy, "label-widget", PropertyObject);
	AddProperty(proxy, "expanded", PropertyBool);
	AddProperty(proxy, "spacing", PropertyInt);
}

void GtkExpanderInit(GObject * object, Node * node) {
	Node * set= FindNode(node, "label-widget-set");
	if(!set || !ModelGetBool(set))
		gtk_expander_set_label(GTK_EXPANDER(object), "");
}

void PropertyGtkExpanderLabel(PropertyFuncData * data) {
	const gchar * str= ModelGetString(data->node);
	GtkWidget * widget= gtk_expander_get_label_widget(GTK_EXPANDER(data->object)); 
	Check(GTK_IS_LABEL(widget));
	gtk_label_set_label(GTK_LABEL(widget), str);
}

// GtkScrolledWindowProxy ------------------------------------------------------

void GtkScrolledWindowProxy(Proxy * proxy) {
	GtkBinProxy(proxy);
	GtkContainerSetChildrenPropertyFunc(proxy, PropertyGtkScrolledWindowChildren);
	GtkWidgetAddCanFocusProperty(proxy);
	AddProperty(proxy, "hadjustment", PropertyObject);
	AddProperty(proxy, "vadjustment", PropertyObject);
	AddProperty(proxy, "shadow-type", PropertyEnum);
	AddProperty(proxy, "hscrollbar-policy", PropertyEnum);
	AddProperty(proxy, "vscrollbar-policy", PropertyEnum);
	AddProperty(proxy, "window-placement", PropertyEnum);
	AddProperty(proxy, "auto-viewport", PropertyGtkScrolledWindowAutoViewport);
}

void PropertyGtkScrolledWindowChildren(PropertyFuncData * data) {
	PtrArray * children= ModelGetObjectVector(data->loader, data->node);
	ContainerScrolledWindowSet(GTK_SCROLLED_WINDOW(data->object), children);
	FreeObjectVector(children);
}

void PropertyGtkScrolledWindowAutoViewport(PropertyFuncData * data) {
	GObject * widget= G_OBJECT(gtk_bin_get_child(GTK_BIN(data->object)));
	Check(widget && g_object_get_data(widget, "GideonAutoViewportHint"));
	ModelGetObject(data->loader, data->node, widget);
}

// GtkHandleBoxProxy -----------------------------------------------------------

void GtkHandleBoxProxy(Proxy * proxy) {
	GtkBinProxy(proxy);
	AddInitInstance(proxy, GtkHandleBoxInit);
	GtkWidgetAddEventProperties(proxy);
	AddProperty(proxy, "handle-position", PropertyEnum);
	AddProperty(proxy, "shadow-type", PropertyEnum);
	AddProperty(proxy, "snap-edge-set", PropertyBool);
	AddProperty(proxy, "snap-edge", PropertyEnum);
}

void GtkHandleBoxInit(GObject * object, Node * node) {
	gtk_handle_box_set_shadow_type(GTK_HANDLE_BOX(object), GTK_SHADOW_ETCHED_OUT);
}

// GtkViewportProxy ------------------------------------------------------------

void GtkViewportProxy(Proxy * proxy) {
	GtkBinProxy(proxy);
	GtkWidgetAddEventProperties(proxy);
	AddProperty(proxy, "shadow-type", PropertyEnum);
}

// GideonBoxChildProxy ---------------------------------------------------------

void GideonBoxChildProxy(Proxy * proxy) {
	GideonChildProxy(proxy);
	GideonChildAddIndexProperty(proxy);
	AddProperty(proxy, "pack", PropertyGideonBoxChildPack);
	AddProperty(proxy, "options", PropertyGideonBoxChildOptions);
	AddProperty(proxy, "padding", PropertyGideonBoxChildPadding);
}

void PropertyGideonBoxChildPack(PropertyFuncData * data) {
	int value= ModelGetInt(data->node);
	GIDEON_CHILD(data->object)->place.b= value;
}

void PropertyGideonBoxChildOptions(PropertyFuncData * data) {
	GideonPackOptions value= ModelGetPackOptions(data->node);
	GIDEON_BOX_CHILD(data->object)->options= value;
}

void PropertyGideonBoxChildPadding(PropertyFuncData * data) {
	unsigned value= ModelGetUnsigned(data->node);
	GIDEON_BOX_CHILD(data->object)->padding= value;
}

// GtkBoxProxy -----------------------------------------------------------------

void GtkBoxProxy(Proxy * proxy) {
	GtkContainerProxy(proxy);
	GtkContainerSetChildrenPropertyFunc(proxy, PropertyGtkBoxChildren);
	AddProperty(proxy, "capacity", PropertyGtkBoxCapacity);
	AddProperty(proxy, "homogeneous", PropertyBool);
	AddProperty(proxy, "spacing", PropertyInt);
}

void PropertyGtkBoxChildren(PropertyFuncData * data) {
	PtrArray * children= ModelGetObjectVector(data->loader, data->node);
	GideonPoint cap= { 0, 0 };
	Node * ncap= FindNode(data->node->owner, "capacity");
	if(ncap)
		cap= ModelGetPoint(ncap);
	ContainerBoxSet(GTK_BOX(data->object), children, cap.x, cap.y);
	FreeObjectVector(children);
}

void PropertyGtkBoxCapacity(PropertyFuncData * data) {
	if(ContainerIsEmpty(GTK_CONTAINER(data->object))) {
		GideonPoint cap= ModelGetPoint(data->node);
		ContainerBoxSet(GTK_BOX(data->object), NULL, cap.x, cap.y);
	}
}

// GideonButtonBoxChildProxy ---------------------------------------------------

void GideonButtonBoxChildProxy(Proxy * proxy) {
	GideonBoxChildProxy(proxy);
	AddProperty(proxy, "secondary", PropertyGideonButtonBoxChildSecondary);
}

void PropertyGideonButtonBoxChildSecondary(PropertyFuncData * data) {
	gboolean value= ModelGetBool(data->node);
	GIDEON_BUTTON_BOX_CHILD(data->object)->secondary= value;
}

// GtkButtonBoxProxy -----------------------------------------------------------

void GtkButtonBoxProxy(Proxy * proxy) {
	GtkBoxProxy(proxy);
	GtkContainerSetChildrenPropertyFunc(proxy, PropertyGtkButtonBoxChildren);
	FindProperty(proxy, "capacity")->assign= PropertyGtkButtonBoxCapacity;
	AddProperty(proxy, "layout-style", PropertyEnum);	
}

void PropertyGtkButtonBoxChildren(PropertyFuncData * data) {
	PtrArray * children= ModelGetObjectVector(data->loader, data->node);
	GideonPoint cap= { 0, };
	Node * ncap= FindNode(data->node->owner, "capacity");
	if(ncap)
		cap= ModelGetPoint(ncap);
	ContainerButtonBoxSet(GTK_BUTTON_BOX(data->object), children, cap.x, cap.y);
	FreeObjectVector(children);
}

void PropertyGtkButtonBoxCapacity(PropertyFuncData * data) {
	if(ContainerIsEmpty(GTK_CONTAINER(data->object))) {
		GideonPoint cap= ModelGetPoint(data->node);
		ContainerButtonBoxSet(GTK_BUTTON_BOX(data->object), NULL, cap.x, cap.y);
	}
}

// GideonPanedChildProxy -------------------------------------------------------

void GideonPanedChildProxy(Proxy * proxy) {
	GideonChildProxy(proxy);
	GideonChildAddIndexProperty(proxy);
	AddProperty(proxy, "resize", PropertyGideonPanedChildResize);
	AddProperty(proxy, "shrink", PropertyGideonPanedChildShrink);
}

void PropertyGideonPanedChildResize(PropertyFuncData * data) {
	gboolean value= ModelGetBool(data->node);
	GIDEON_PANED_CHILD(data->object)->resize= value;
}

void PropertyGideonPanedChildShrink(PropertyFuncData * data) {
	gboolean value= ModelGetBool(data->node);
	GIDEON_PANED_CHILD(data->object)->shrink= value;
}

// GtkPanedProxy ---------------------------------------------------------------

void GtkPanedProxy(Proxy * proxy) {
	GtkContainerProxy(proxy);
	GtkContainerSetChildrenPropertyFunc(proxy, PropertyGtkPanedChildren);
	GtkWidgetAddCanFocusProperty(proxy);
	AddProperty(proxy, "position-set", PropertyBool);
	AddProperty(proxy, "position", PropertyInt);
}

void PropertyGtkPanedChildren(PropertyFuncData * data) {
	PtrArray * children= ModelGetObjectVector(data->loader, data->node);
	ContainerPanedSet(GTK_PANED(data->object), children);
	FreeObjectVector(children);
}

// GideonNotebookChildProxy ----------------------------------------------------

void GideonNotebookChildProxy(Proxy * proxy) {
	GideonChildProxy(proxy);
	GideonChildAddIndexProperty(proxy);
	AddProperty(proxy, "tab-label", PropertyGideonNotebookChildTabLabel);
	AddProperty(proxy, "tab-label-widget", PropertyGideonNotebookChildTabLabelWidget);
	AddProperty(proxy, "menu-label", PropertyGideonNotebookChildMenuLabel);
	AddProperty(proxy, "menu-label-widget", PropertyGideonNotebookChildMenuLabelWidget);
	AddProperty(proxy, "pack-options", PropertyGideonNotebookChildPackOptions);
}

void PropertyGideonNotebookChildTabLabel(PropertyFuncData * data) {
	const gchar * value= ModelGetString(data->node);
	GIDEON_NOTEBOOK_CHILD(data->object)->tabLabel= value;
}

void PropertyGideonNotebookChildTabLabelWidget(PropertyFuncData * data) {
	GObject * value= ModelGetObject(data->loader, data->node, NULL);
	GIDEON_NOTEBOOK_CHILD(data->object)->tabLabelWidget= GTK_WIDGET(value);
}

void PropertyGideonNotebookChildMenuLabel(PropertyFuncData * data) {
	const gchar * value= ModelGetString(data->node);
	GIDEON_NOTEBOOK_CHILD(data->object)->menuLabel= value;
}

void PropertyGideonNotebookChildMenuLabelWidget(PropertyFuncData * data) {
	GObject * value= ModelGetObject(data->loader, data->node, NULL);
	GIDEON_NOTEBOOK_CHILD(data->object)->menuLabelWidget= GTK_WIDGET(value);
}

void PropertyGideonNotebookChildPackOptions(PropertyFuncData * data) {
	GideonPackOptions value= ModelGetPackOptions(data->node);
	GIDEON_NOTEBOOK_CHILD(data->object)->packOptions= value;
}

// GtkNotebookProxy ------------------------------------------------------------

void GtkNotebookProxy(Proxy * proxy) {
	GtkContainerProxy(proxy);
	GtkContainerSetChildrenPropertyFunc(proxy, PropertyGtkNotebookChildren);
	AddProperty(proxy, "capacity", PropertyGtkNotebookCapacity);
	GtkWidgetAddCanFocusProperty(proxy);
	AddProperty(proxy, "enable-popup", PropertyBool);
	AddProperty(proxy, "homogeneous", PropertyBool);
	AddProperty(proxy, "page", PropertyInt);
	AddProperty(proxy, "scrollable", PropertyBool);
	AddProperty(proxy, "show-border", PropertyBool);
	AddProperty(proxy, "show-tabs", PropertyBool);
	AddProperty(proxy, "tab-hborder", PropertyUnsigned);
	AddProperty(proxy, "tab-vborder", PropertyUnsigned);
	AddProperty(proxy, "tab-pos", PropertyEnum);
}

void PropertyGtkNotebookChildren(PropertyFuncData * data) {
	PtrArray * children= ModelGetObjectVector(data->loader, data->node);
	int cap= 0;
	Node * ncap= FindNode(data->node->owner, "capacity");
	if(ncap)
		cap= ModelGetInt(ncap);
	ContainerNotebookSet(GTK_NOTEBOOK(data->object), children, cap);
	FreeObjectVector(children);
}

void PropertyGtkNotebookCapacity(PropertyFuncData * data) {
	if(ContainerIsEmpty(GTK_CONTAINER(data->object))) {
		int cap= ModelGetInt(data->node);
		ContainerNotebookSet(GTK_NOTEBOOK(data->object), NULL, cap);
	}
}

// GideonTableChildProxy -------------------------------------------------------

void GideonTableChildProxy(Proxy * proxy) {
	GideonChildProxy(proxy);
	AddProperty(proxy, "cell", PropertyGideonTableChildCell);
	AddProperty(proxy, "cell-span", PropertyGideonTableChildCellSpan);
	AddProperty(proxy, "padding-x", PropertyGideonTableChildPaddingX);
	AddProperty(proxy, "padding-y", PropertyGideonTableChildPaddingY);
	AddProperty(proxy, "x-expand", PropertyGideonTableChildXExpand);
	AddProperty(proxy, "x-fill", PropertyGideonTableChildXFill);
	AddProperty(proxy, "x-shrink", PropertyGideonTableChildXShrink);
	AddProperty(proxy, "y-expand", PropertyGideonTableChildYExpand);
	AddProperty(proxy, "y-fill", PropertyGideonTableChildYFill);
	AddProperty(proxy, "y-shrink", PropertyGideonTableChildYShrink);
}

void PropertyGideonTableChildCell(PropertyFuncData * data) {
	GideonPoint value= ModelGetPoint(data->node);
	GIDEON_CHILD(data->object)->place.a= value.x;
	GIDEON_CHILD(data->object)->place.b= value.y;
}

void PropertyGideonTableChildCellSpan(PropertyFuncData * data) {
	GideonPoint value= ModelGetPoint(data->node);
	GIDEON_CHILD(data->object)->place.c= value.x;
	GIDEON_CHILD(data->object)->place.d= value.y;
}

void PropertyGideonTableChildPaddingX(PropertyFuncData * data) {
	unsigned value= ModelGetUnsigned(data->node);
	GIDEON_TABLE_CHILD(data->object)->paddingX= value;
}

void PropertyGideonTableChildPaddingY(PropertyFuncData * data) {
	unsigned value= ModelGetUnsigned(data->node);
	GIDEON_TABLE_CHILD(data->object)->paddingY= value;
}

void PropertyGideonTableChildXExpand(PropertyFuncData * data) {
	gboolean value= ModelGetBool(data->node);
	GIDEON_TABLE_CHILD(data->object)->xExpand= value;
}

void PropertyGideonTableChildXFill(PropertyFuncData * data) {
	gboolean value= ModelGetBool(data->node);
	GIDEON_TABLE_CHILD(data->object)->xFill= value;
}

void PropertyGideonTableChildXShrink(PropertyFuncData * data) {
	gboolean value= ModelGetBool(data->node);
	GIDEON_TABLE_CHILD(data->object)->xShrink= value;
}

void PropertyGideonTableChildYExpand(PropertyFuncData * data) {
	gboolean value= ModelGetBool(data->node);
	GIDEON_TABLE_CHILD(data->object)->yExpand= value;
}

void PropertyGideonTableChildYFill(PropertyFuncData * data) {
	gboolean value= ModelGetBool(data->node);
	GIDEON_TABLE_CHILD(data->object)->yFill= value;
}

void PropertyGideonTableChildYShrink(PropertyFuncData * data) {
	gboolean value= ModelGetBool(data->node);
	GIDEON_TABLE_CHILD(data->object)->yShrink= value;
}

// GtkTableProxy ---------------------------------------------------------------

void GtkTableProxy(Proxy * proxy) {
	GtkContainerProxy(proxy);
	SetCreateInstance(proxy, GtkTableCreate);
	GtkContainerSetChildrenPropertyFunc(proxy, PropertyGtkTableChildren);
	AddProperty(proxy, "capacity", PropertyGtkTableCapacity);
	AddProperty(proxy, "column-spacing", PropertyUnsigned);
	AddProperty(proxy, "homogeneous", PropertyBool);
	AddProperty(proxy, "row-spacing", PropertyUnsigned);
}

GObject * GtkTableCreate(GuiLoader * loader, Node * node) {
	return G_OBJECT(gtk_table_new(1, 1, FALSE));
}

void PropertyGtkTableChildren(PropertyFuncData * data) {
	PtrArray * children= ModelGetObjectVector(data->loader, data->node);
	GideonPoint cap= { 1, 1 };
	Node * ncap= FindNode(data->node->owner, "capacity");
	if(ncap)
		cap= ModelGetPoint(ncap);
	ContainerTableSet(GTK_TABLE(data->object), children, cap.x, cap.y);
	FreeObjectVector(children);
}

void PropertyGtkTableCapacity(PropertyFuncData * data) {
	if(ContainerIsEmpty(GTK_CONTAINER(data->object))) {
		GideonPoint cap= ModelGetPoint(data->node);
		ContainerTableSet(GTK_TABLE(data->object), NULL, cap.x, cap.y);
	}
}

// GideonXYChild ---------------------------------------------------------------

void GideonXYChildProxy(Proxy * proxy) {
	GideonChildProxy(proxy);
	AddProperty(proxy, "xy", PropertyGideonXYChildXY);
}

void PropertyGideonXYChildXY(PropertyFuncData * data) {
	GideonPoint value= ModelGetPoint(data->node);
	GIDEON_CHILD(data->object)->place.a= value.x;
	GIDEON_CHILD(data->object)->place.b= value.y;
}

// GtkAdjustmentProxy ----------------------------------------------------------

void GtkAdjustmentProxy(Proxy * proxy) {
	GObjectProxy(proxy);
	AddProperty(proxy, "lower", PropertyDouble);
	AddProperty(proxy, "upper", PropertyDouble);
	AddProperty(proxy, "page-size", PropertyDouble);
	AddProperty(proxy, "page-increment", PropertyDouble);
	AddProperty(proxy, "step-increment", PropertyDouble);
	AddProperty(proxy, "value", PropertyDouble);
}

// GtkWindowProxy --------------------------------------------------------------

void GtkWindowProxy(Proxy * proxy) {
	GtkBinProxy(proxy);
	SetCreateInstance(proxy, GtkWindowCreate);
	GtkWidgetAddAppPaintableProperty(proxy);
	GtkWidgetAddEventProperties(proxy);
	AddProperty(proxy, "accept-focus", PropertyBool);
	AddProperty(proxy, "decorated", PropertyBool);
	AddProperty(proxy, "default-size", PropertyGtkWindowDefaultSize);
	AddProperty(proxy, "focus-on-map", PropertyBool);
	AddProperty(proxy, "gravity", PropertyEnum);
	AddProperty(proxy, "icon-name", PropertyString);
	AddProperty(proxy, "modal", PropertyBool);
	AddProperty(proxy, "resizable", PropertyBool);
	AddProperty(proxy, "role", PropertyString);
	AddProperty(proxy, "skip-pager-hint", PropertyBool);
	AddProperty(proxy, "skip-taskbar-hint", PropertyBool);
	AddProperty(proxy, "title", PropertyString);
	AddProperty(proxy, "type-hint", PropertyEnum);
	AddProperty(proxy, "window-position", PropertyEnum);
	AddProperty(proxy, "accel-groups", PropertyGtkWindowAccelGroups);
	AddProperty(proxy, "transient-for", PropertyGtkWindowTransientFor);
	AddProperty(proxy, "default", PropertyGtkWindowDefault);
	AddProperty(proxy, "urgency-hint", PropertyBool);
}

GObject * GtkWindowCreate(GuiLoader * loader, Node * node) {
	GtkWindowType type= GTK_WINDOW_TOPLEVEL;
	GObject * object;
	gulong hid;
	if(!GUI_LOADER_GET_PRIVATE(loader)->preview) {
		Node * set= FindNode(node, "type");
		if(set && ModelGetEnum(set)==GTK_WINDOW_POPUP)
			type= GTK_WINDOW_POPUP;
	}
	object= G_OBJECT(gtk_window_new(type));
	hid= g_signal_connect(object, "delete-event", G_CALLBACK(GtkWindowOnDeleteEvent), NULL);
	g_object_set_data(object, "GuiLoaderOnDeleteEvent", GUINT_TO_POINTER(hid));
	return object;
}

gboolean GtkWindowOnDeleteEvent(GObject * window) {
	gulong hid= GPOINTER_TO_UINT(g_object_get_data(window, "GuiLoaderOnDeleteEvent"));
	guint sid;
	gboolean pending;
	Check(hid);
	g_signal_handler_block(window, hid);
	sid= g_signal_lookup("delete-event", GTK_TYPE_WINDOW);
	pending= g_signal_has_handler_pending(window, sid, 0, FALSE);
	if(!pending)
		gtk_widget_hide(GTK_WIDGET(window));
	g_signal_handler_unblock(window, hid);
	return !pending;
}

void PropertyGtkWindowDefaultSize(PropertyFuncData * data) {
	GideonPoint value= ModelGetPoint(data->node);
	gtk_window_set_default_size(GTK_WINDOW(data->object), value.x, value.y);
}

void PropertyGtkWindowAccelGroups(PropertyFuncData * data) {
	GtkWindow * window= GTK_WINDOW(data->object);
	PtrArray * array= ModelGetObjectVector(data->loader, data->node);
	int i;
	for(i= 0; i < array->size; ++i)
		if(array->ptrs[i]) {
			GtkUIManager * manager= GTK_UI_MANAGER(array->ptrs[i]);
			gtk_window_add_accel_group(window, gtk_ui_manager_get_accel_group(manager));
		}
	PtrArrayFree(array);
}

void PropertyGtkWindowTransientFor(PropertyFuncData * data) {
	GObject * value= ModelGetObject(data->loader, data->node, NULL);
	gtk_window_set_transient_for(GTK_WINDOW(data->object), GTK_WINDOW(value));
}

void PropertyGtkWindowDefault(PropertyFuncData * data) {
	GObject * value= ModelGetObject(data->loader, data->node, NULL);
	gtk_window_set_default(GTK_WINDOW(data->object), GTK_WIDGET(value));
}

// GideonDialogButtonEntry -----------------------------------------------------

GType gideon_dialog_button_entry_get_type(void) {
	static GType object_type= 0;
	if(object_type==0) {
		static const GTypeInfo object_info= {
			sizeof(GObjectClass), 
			NULL, NULL, NULL, NULL, NULL, 
			sizeof(GideonDialogButtonEntry), 
			0, (GInstanceInitFunc)gideon_dialog_button_entry_init,
		};
		object_type= g_type_register_static(G_TYPE_OBJECT, "GideonDialogButtonEntry", &object_info, 0);
	}
	return object_type;
}

void gideon_dialog_button_entry_init(GideonDialogButtonEntry * entry) {
	entry->widget= NULL;
	entry->response= GTK_RESPONSE_NONE;
	entry->secondary= FALSE;
}

// GideonDialogButtonEntryProxy ------------------------------------------------

void GideonDialogButtonEntryProxy(Proxy * proxy) {
	GObjectProxy(proxy);
	AddProperty(proxy, "widget", PropertyGideonDialogButtonEntryWidget);
	AddProperty(proxy, "response", PropertyGideonDialogButtonEntryResponse);
	AddProperty(proxy, "secondary", PropertyGideonDialogButtonEntrySecondary);
}

void PropertyGideonDialogButtonEntryWidget(PropertyFuncData * data) {
	GObject * value= ModelGetObject(data->loader, data->node, NULL);
	GIDEON_DIALOG_BUTTON_ENTRY(data->object)->widget= GTK_WIDGET(value);
}

void PropertyGideonDialogButtonEntryResponse(PropertyFuncData * data) {
	gint value= ModelGetEnum(data->node);
	GIDEON_DIALOG_BUTTON_ENTRY(data->object)->response= value;
}

void PropertyGideonDialogButtonEntrySecondary(PropertyFuncData * data) {
	gboolean value= ModelGetBool(data->node);
	GIDEON_DIALOG_BUTTON_ENTRY(data->object)->secondary= value;
}

// GtkDialogProxy --------------------------------------------------------------

void GtkDialogProxy(Proxy * proxy) {
	GtkWindowProxy(proxy);
	SetCreateInstance(proxy, NULL);
	GtkContainerSetChildrenPropertyFunc(proxy, PropertyGtkDialogChildren);
	AddProperty(proxy, "has-separator", PropertyBool);
	AddProperty(proxy, "buttons", PropertyGtkDialogButtons);
	AddProperty(proxy, "default-response", PropertyGtkDialogDefaultResponse);
}

void PropertyGtkDialogChildren(PropertyFuncData * data) {
	PtrArray * children= ModelGetObjectVector(data->loader, data->node);
	ContainerDialogSet(GTK_DIALOG(data->object), children);
	FreeObjectVector(children);
}

void PropertyGtkDialogButtons(PropertyFuncData * data) {
	GtkDialog * dialog= GTK_DIALOG(data->object);
	PtrArray * array= ModelGetObjectVector(data->loader, data->node);
	int i;
	for(i= 0; i < array->size; ++i)
		if(array->ptrs[i]) {
			GideonDialogButtonEntry * entry= GIDEON_DIALOG_BUTTON_ENTRY(array->ptrs[i]);
			if(entry->widget) {
				GtkButtonBox * area= GTK_BUTTON_BOX(dialog->action_area);
				if(entry->response != GTK_RESPONSE_NONE)
					gtk_dialog_add_action_widget(dialog, entry->widget, entry->response);
				else
					gtk_box_pack_end(GTK_BOX(area), entry->widget, FALSE, TRUE, 0);
				gtk_button_box_set_child_secondary(area, entry->widget, entry->secondary);
			}
		}
	FreeObjectVector(array);
}

void PropertyGtkDialogDefaultResponse(PropertyFuncData * data) {
	gint value= ModelGetEnum(data->node);
	gtk_dialog_set_default_response(GTK_DIALOG(data->object), value);
}

// GtkColorSelectionDialogProxy ------------------------------------------------

void GtkColorSelectionDialogProxy(Proxy * proxy) {
	GtkDialogProxy(proxy);
	AddInitInstance(proxy, GtkColorSelectionDialogInit);
	AddProperty(proxy, "colorsel", PropertyGtkColorSelectionDialogColorsel);
}

void GtkColorSelectionDialogInit(GObject * object, Node * node) {
	GtkWidget * colorsel= GTK_COLOR_SELECTION_DIALOG(object)->colorsel;
	GdkColor color= { 0, };
	gtk_color_selection_set_current_color(GTK_COLOR_SELECTION(colorsel), &color);
}

void PropertyGtkColorSelectionDialogColorsel(PropertyFuncData * data) {
	GtkWidget * widget= GTK_COLOR_SELECTION_DIALOG(data->object)->colorsel;
	Check(widget);
	ModelGetObject(data->loader, data->node, G_OBJECT(widget));
}

// GtkFileFilterProxy ----------------------------------------------------------

void GtkFileFilterProxy(Proxy * proxy) {
	GObjectProxy(proxy);
	AddProperty(proxy, "name", PropertyGtkFileFilterName);
	AddProperty(proxy, "add-pixbuf-formats", PropertyGtkFileFilterAddPixbufFormats);
	AddProperty(proxy, "patterns", PropertyGtkFileFilterPatterns);
	AddProperty(proxy, "mime-types", PropertyGtkFileFilterMimeTypes);
}

void PropertyGtkFileFilterName(PropertyFuncData * data) {
	const gchar * value= ModelGetString(data->node);
	gtk_file_filter_set_name(GTK_FILE_FILTER(data->object), value);
}

void PropertyGtkFileFilterAddPixbufFormats(PropertyFuncData * data) {
	gboolean value= ModelGetBool(data->node);
	if(value)
		gtk_file_filter_add_pixbuf_formats(GTK_FILE_FILTER(data->object));
}

void PropertyGtkFileFilterPatterns(PropertyFuncData * data) {
	GtkFileFilter * filter= GTK_FILE_FILTER(data->object);
	PtrArray * array= ModelGetStringVector(data->node);
	int i;
	for(i= 0; i < array->size; ++i)
		gtk_file_filter_add_pattern(filter, array->ptrs[i]);
	PtrArrayFree(array);
}

void PropertyGtkFileFilterMimeTypes(PropertyFuncData * data) {
	GtkFileFilter * filter= GTK_FILE_FILTER(data->object);
	PtrArray * array= ModelGetStringVector(data->node);
	int i;
	for(i= 0; i < array->size; ++i)
		gtk_file_filter_add_mime_type(filter, array->ptrs[i]);
	PtrArrayFree(array);
}

// GtkFileChooserProxyBase -----------------------------------------------------

void GtkFileChooserProxyBase(Proxy * proxy) {
	GtkWidgetProxy(proxy);
	AddProperty(proxy, "action", PropertyEnum);
	AddProperty(proxy, "extra-widget", PropertyObject);
	AddProperty(proxy, "local-only", PropertyBool);
	AddProperty(proxy, "preview-widget", PropertyObject);
	AddProperty(proxy, "preview-widget-active", PropertyBool);
	AddProperty(proxy, "select-multiple", PropertyBool);
	AddProperty(proxy, "show-hidden", PropertyBool);
	AddProperty(proxy, "use-preview-label", PropertyBool);
	AddProperty(proxy, "filter", PropertyGtkFileChooserBaseFilter);
	AddProperty(proxy, "filters", PropertyGtkFileChooserBaseFilters);
	AddProperty(proxy, "do-overwrite-confirmation", PropertyBool);
}

void PropertyGtkFileChooserBaseFilter(PropertyFuncData * data) {
	GObject * filter= ModelGetObject(data->loader, data->node, NULL);
	gtk_file_chooser_set_filter(GTK_FILE_CHOOSER(data->object), GTK_FILE_FILTER(filter));
}

void PropertyGtkFileChooserBaseFilters(PropertyFuncData * data) {
	GtkFileChooser * chooser= GTK_FILE_CHOOSER(data->object);
	PtrArray * array= ModelGetObjectVector(data->loader, data->node);
	int i;
	for(i= 0; i < array->size; ++i)
		if(array->ptrs[i]) {
			GtkFileFilter * filter= GTK_FILE_FILTER(array->ptrs[i]);
			gtk_file_chooser_add_filter(chooser, filter);
		}
	PtrArrayFree(array);
}

// GtkFileChooserDialogProxy ---------------------------------------------------

void GtkFileChooserDialogProxy(Proxy * proxy) {
	GtkDialogProxy(proxy);
	GtkFileChooserProxyBase(proxy);
	SetCreateInstance(proxy, GtkFileChooserDialogCreate);
}

GObject * GtkFileChooserDialogCreate(GuiLoader * loader, Node * node) {
	Node * fsb= FindNode(node, "file-system-backend");
	const gchar * backend= fsb ? ModelGetString(fsb) : NULL;
	if(!backend)
		return G_OBJECT(gtk_file_chooser_dialog_new("", NULL, GTK_FILE_CHOOSER_ACTION_OPEN, NULL, NULL)); else
		return G_OBJECT(gtk_file_chooser_dialog_new_with_backend("", NULL, GTK_FILE_CHOOSER_ACTION_OPEN, backend, NULL, NULL));
}

// GtkFontSelectionDialogProxy -------------------------------------------------

void GtkFontSelectionDialogProxy(Proxy * proxy) {
	GtkDialogProxy(proxy);
	AddProperty(proxy, "font-selection", PropertyGtkFontSelectionDialogFontSelection);
}

void PropertyGtkFontSelectionDialogFontSelection(PropertyFuncData * data) {
	GtkWidget * widget= GTK_FONT_SELECTION_DIALOG(data->object)->fontsel;
	Check(widget);
	ModelGetObject(data->loader, data->node, G_OBJECT(widget));
}

// GtkStatusbarProxy -----------------------------------------------------------

void GtkStatusbarProxy(Proxy * proxy) {
	GtkContainerProxyBase(proxy);
	AddProperty(proxy, "has-resize-grip", PropertyBool);
}

// GideonTooltipsEntry ---------------------------------------------------------

GType gideon_tooltips_entry_get_type(void) {
	static GType object_type= 0;
	if(object_type==0) {
		static const GTypeInfo object_info= {
			sizeof(GObjectClass), 
			NULL, NULL, NULL, NULL, NULL, 
			sizeof(GideonTooltipsEntry), 
			0, (GInstanceInitFunc)gideon_tooltips_entry_init,
		};
		object_type= g_type_register_static(G_TYPE_OBJECT, "GideonTooltipsEntry", &object_info, 0);
	}
	return object_type;
}

void gideon_tooltips_entry_init(GideonTooltipsEntry * entry) {
	entry->widget= NULL;
	entry->tip_text= NULL;
	entry->tip_private= NULL;
}

// GideonTooltipsEntryProxy ----------------------------------------------------

void GideonTooltipsEntryProxy(Proxy * proxy) {
	GObjectProxy(proxy);
	AddProperty(proxy, "widget", PropertyGideonTooltipsEntryWidget);
	AddProperty(proxy, "tip-text", PropertyGideonTooltipsEntryTipText);
	AddProperty(proxy, "tip-private", PropertyGideonTooltipsEntryTipPrivate);
}

void PropertyGideonTooltipsEntryWidget(PropertyFuncData * data) {
	GObject * value= ModelGetObject(data->loader, data->node, NULL);
	GIDEON_TOOLTIPS_ENTRY(data->object)->widget= GTK_WIDGET(value);
}

void PropertyGideonTooltipsEntryTipText(PropertyFuncData * data) {
	const gchar * value= ModelGetString(data->node);
	GIDEON_TOOLTIPS_ENTRY(data->object)->tip_text= value;
}

void PropertyGideonTooltipsEntryTipPrivate(PropertyFuncData * data) {
	const gchar * value= ModelGetString(data->node);
	GIDEON_TOOLTIPS_ENTRY(data->object)->tip_private= value;
}

// GtkTooltipsProxy ------------------------------------------------------------

void GtkTooltipsProxy(Proxy * proxy) {
	GObjectProxy(proxy);
	AddProperty(proxy, "enabled", PropertyGtkTooltipsEnabled);
	AddProperty(proxy, "tips", PropertyGtkTooltipsTips);
}

void PropertyGtkTooltipsEnabled(PropertyFuncData * data) {
	gboolean value= ModelGetBool(data->node);
	if(!value)
		gtk_tooltips_disable(GTK_TOOLTIPS(data->object));
}

void PropertyGtkTooltipsTips(PropertyFuncData * data) {
	GtkTooltips * tooltips= GTK_TOOLTIPS(data->object);
	PtrArray * array= ModelGetObjectVector(data->loader, data->node);
	int i;
	for(i= 0; i < array->size; ++i)
		if(array->ptrs[i]) {
			GideonTooltipsEntry * entry= GIDEON_TOOLTIPS_ENTRY(array->ptrs[i]);
			if(entry->widget)
				gtk_tooltips_set_tip(tooltips, entry->widget, entry->tip_text, entry->tip_private);
		}
	FreeObjectVector(array);
}

// GtkActionGroupProxy ---------------------------------------------------------

void GtkActionGroupProxy(Proxy * proxy) {
	GObjectProxy(proxy);
	SetCreateInstance(proxy, GtkActionGroupCreate);
	AddProperty(proxy, "actions", PropertyGtkActionGroupActions);
	AddProperty(proxy, "sensitive", PropertyBool);
	AddProperty(proxy, "visible", PropertyBool);
}

GObject * GtkActionGroupCreate(GuiLoader * loader, Node * node) {
	Node * nname= FindNode(node, "name");
	const gchar * name= nname ? ModelGetString(nname) : "";
	return G_OBJECT(gtk_action_group_new(name));
}

void PropertyGtkActionGroupActions(PropertyFuncData * data) {
	GtkActionGroup * group= GTK_ACTION_GROUP(data->object);
	PtrArray * array= ModelGetObjectVector(data->loader, data->node);
	int i;
	for(i= 0; i < array->size; ++i)
		if(array->ptrs[i]) {
			GtkAction * action= GTK_ACTION(array->ptrs[i]);
			const gchar * accel= g_object_get_data(G_OBJECT(action), "GideonAcceleratorHint");
			if(!accel)
				gtk_action_group_add_action_with_accel(group, action, NULL); else
				gtk_action_group_add_action_with_accel(group, action, accel);				
		}
	PtrArrayFree(array);
}

// GtkActionProxy --------------------------------------------------------------

void GtkActionProxy(Proxy * proxy) {
	GObjectProxy(proxy);
	SetCreateInstance(proxy, GtkActionCreate);
	AddProperty(proxy, "hide-if-empty", PropertyBool);
	AddProperty(proxy, "is-important", PropertyBool);
	AddProperty(proxy, "label", PropertyString);
	AddProperty(proxy, "sensitive", PropertyBool);
	AddProperty(proxy, "stock-id", PropertyString);
	AddProperty(proxy, "tooltip", PropertyString);
	AddProperty(proxy, "visible", PropertyBool);
	AddProperty(proxy, "visible-horizontal", PropertyBool);
	AddProperty(proxy, "visible-overflown", PropertyBool);
	AddProperty(proxy, "visible-vertical", PropertyBool);
	AddProperty(proxy, "accelerator", PropertyGtkActionAccelerator);
}

GObject * GtkActionCreate(GuiLoader * loader, Node * node) {
	Node * nname= FindNode(node, "name");
	const gchar * name= nname ? ModelGetString(nname) : "";
	return G_OBJECT(gtk_action_new(name, NULL, NULL, ""));
}

void PropertyGtkActionAccelerator(PropertyFuncData * data) {
	const gchar * value= ModelGetString(data->node);
	g_object_set_data(data->object, "GideonAcceleratorHint", (gpointer)value);
}

// GtkToggleActionProxy --------------------------------------------------------

void GtkToggleActionProxy(Proxy * proxy) {
	GtkActionProxy(proxy);
	SetCreateInstance(proxy, GtkToggleActionCreate);
	AddProperty(proxy, "draw-as-radio", PropertyBool);
	AddProperty(proxy, "active", PropertyGtkToggleActionActive);
}

GObject * GtkToggleActionCreate(GuiLoader * loader, Node * node) {
	Node * nname= FindNode(node, "name");
	const gchar * name= nname ? ModelGetString(nname) : "";
	return G_OBJECT(gtk_toggle_action_new(name, NULL, NULL, ""));
}

void PropertyGtkToggleActionActive(PropertyFuncData * data) {
	gboolean value= ModelGetBool(data->node);
	gtk_toggle_action_set_active(GTK_TOGGLE_ACTION(data->object), value);
}

// GtkRadioActionProxy ---------------------------------------------------------

void GtkRadioActionProxy(Proxy * proxy) {
	GtkToggleActionProxy(proxy);
	SetCreateInstance(proxy, GtkRadioActionCreate);
	AddProperty(proxy, "value", PropertyInt);
	AddProperty(proxy, "group", PropertyGtkRadioActionGroup);
	SetPropertyLazy(proxy, "active", TRUE);
}

GObject * GtkRadioActionCreate(GuiLoader * loader, Node * node) {
	Node * nname= FindNode(node, "name");
	const gchar * name= nname ? ModelGetString(nname) : "";
	return G_OBJECT(gtk_radio_action_new(name, NULL, NULL, "", 0));
}

void PropertyGtkRadioActionGroup(PropertyFuncData * data) {
	GObject * object= ModelGetObject(data->loader, data->node, NULL);
	GideonRadioGroup * group= GIDEON_RADIO_GROUP(object);
	GtkRadioAction * action= GTK_RADIO_ACTION(data->object);
	gtk_radio_action_set_group(action, group->list);
	group->list= gtk_radio_action_get_group(action);
}

// GtkUIManagerProxy -----------------------------------------------------------

void GtkUIManagerProxy(Proxy * proxy) {
	GObjectProxy(proxy);
	AddProperty(proxy, "add-tearoffs", PropertyBool);
	AddProperty(proxy, "action-groups", PropertyGtkUIManagerActionGroups);
	AddProperty(proxy, "ui-definitions", PropertyGtkUIManagerUiDefinitions);
}

void PropertyGtkUIManagerActionGroups(PropertyFuncData * data) {
	GtkUIManager * manager= GTK_UI_MANAGER(data->object);
	PtrArray * array= ModelGetObjectVector(data->loader, data->node);
	int i;
	for(i= 0; i < array->size; ++i)
		if(array->ptrs[i]) {
			GtkActionGroup * group= GTK_ACTION_GROUP(array->ptrs[i]);
			gtk_ui_manager_insert_action_group(manager, group, 0);
		}
	PtrArrayFree(array);
}

void PropertyGtkUIManagerUiDefinitions(PropertyFuncData * data) {
	GtkUIManager * manager= GTK_UI_MANAGER(data->object);
	PtrArray * array= ModelGetObjectVector(data->loader, data->node);
	int i;
	for(i= 0; i < array->size; ++i)
		if(array->ptrs[i]) {
			GideonUIDefinition * definition= GIDEON_UI_DEFINITION(array->ptrs[i]);
			guint id= gtk_ui_manager_add_ui_from_string(manager, definition->ui, -1, NULL);
			g_object_set_data(G_OBJECT(definition), "GideonMergeIdHint", GUINT_TO_POINTER(id));
		}
	PtrArrayFree(array);
}

// GideonUIDefinition ----------------------------------------------------------

GType gideon_ui_definition_get_type(void) {
	static GType object_type= 0;
	if(object_type==0) {
		static const GTypeInfo object_info= {
			sizeof(GObjectClass), 
			NULL, NULL, NULL, NULL, NULL, 
			sizeof(GideonUIDefinition), 
			0, (GInstanceInitFunc)gideon_ui_definition_init,
		};
		object_type= g_type_register_static(G_TYPE_OBJECT, "GideonUIDefinition", &object_info, 0);
	}
	return object_type;
}

void gideon_ui_definition_init(GideonUIDefinition * definition) {
	definition->ui= NULL;
}

// GideonUIDefinitionProxy -----------------------------------------------------

void GideonUIDefinitionProxy(Proxy * proxy) {
	GObjectProxy(proxy);
	AddProperty(proxy, "ui", PropertyGideonUIDefinitionUi);
}

void PropertyGideonUIDefinitionUi(PropertyFuncData * data) {
	const gchar * value= ModelGetString(data->node);
	GIDEON_UI_DEFINITION(data->object)->ui= value;
	//AddSharedStr(data->loader, data->node->text);
}

// GideonUIElementProxy --------------------------------------------------------

void GideonUIElementProxy(Proxy * proxy) {
	GtkContainerProxyBase(proxy);
	SetCreateInstance(proxy, GideonUIElementCreate);
}

GObject * GideonUIElementCreate(GuiLoader * loader, Node * node) {
	Node * nelement= FindNode(node, "element");
	const gchar * element= nelement ? ModelGetString(nelement) : NULL;
	Node * nmanager= FindNode(node, "manager");
	GObject * manager= nmanager ? ModelGetObject(loader, nmanager, NULL) : NULL;
	GtkWidget * widget= NULL;
	if(element && manager) {
		gchar path[256];
		g_snprintf(path, sizeof(path), "/%s", element);
		widget= gtk_ui_manager_get_widget(GTK_UI_MANAGER(manager), path);
	}
	if(widget)
		g_object_ref(widget);
	else {
		if(StrEqual(ShortStrGetStr(node->typename), "GtkMenuBar"))
			widget= gtk_menu_bar_new();
		else {
			Check(StrEqual(ShortStrGetStr(node->typename), "GtkToolbar"));
			widget= gtk_toolbar_new();
		}
	}
	return G_OBJECT(widget);
}

// GtkMenuBarProxy -------------------------------------------------------------

void GtkMenuBarProxy(Proxy * proxy) {
	GideonUIElementProxy(proxy);
	GtkWidgetAddEventProperties(proxy);
	AddProperty(proxy, "take-focus", PropertyBool);
	AddProperty(proxy, "child-pack-direction", PropertyEnum);
	AddProperty(proxy, "pack-direction", PropertyEnum);
}

// GtkToolbarProxy -------------------------------------------------------------

void GtkToolbarProxy(Proxy * proxy) {
	GideonUIElementProxy(proxy);
	AddProperty(proxy, "orientation", PropertyEnum);
	AddProperty(proxy, "show-arrow", PropertyBool);
	AddProperty(proxy, "toolbar-style-set", PropertyGtkToolbarToolbarStyleSet);
	AddProperty(proxy, "toolbar-style", PropertyEnum);
	AddProperty(proxy, "tooltips", PropertyGtkToolbarTooltips);
}

void PropertyGtkToolbarToolbarStyleSet(PropertyFuncData * data) {
	gboolean value= ModelGetBool(data->node);
	if(value)
		gtk_toolbar_set_style(GTK_TOOLBAR(data->object), GTK_TOOLBAR_ICONS);
}

void PropertyGtkToolbarTooltips(PropertyFuncData * data) {
	gboolean value= ModelGetBool(data->node);
	gtk_toolbar_set_tooltips(GTK_TOOLBAR(data->object), value);
}

// GideonRadioGroup ------------------------------------------------------------

GType gideon_radio_group_get_type(void) {
	static GType object_type= 0;
	if(object_type==0) {
		static const GTypeInfo object_info= {
			sizeof(GObjectClass), 
			NULL, NULL, NULL, NULL, NULL, 
			sizeof(GideonRadioGroup), 
			0, (GInstanceInitFunc)gideon_radio_group_init,
		};
		object_type= g_type_register_static(G_TYPE_OBJECT, "GideonRadioGroup", &object_info, 0);
	}
	return object_type;
}

void gideon_radio_group_init(GideonRadioGroup * group) {
	group->list= NULL;
}

// GideonRadioGroupProxy -------------------------------------------------------

void GideonRadioGroupProxy(Proxy * proxy) {
	GObjectProxy(proxy);
}

// GtkMiscProxy ----------------------------------------------------------------

void GtkMiscProxy(Proxy * proxy) {
	GtkWidgetProxy(proxy);
	AddProperty(proxy, "xalign", PropertyFloat);
	AddProperty(proxy, "xpad", PropertyInt);
	AddProperty(proxy, "yalign", PropertyFloat);
	AddProperty(proxy, "ypad", PropertyInt);
}

// GtkLabelProxy ---------------------------------------------------------------

void GtkLabelProxy(Proxy * proxy) {
	GtkMiscProxy(proxy);
	AddProperty(proxy, "angle", PropertyDouble);
	AddProperty(proxy, "ellipsize", PropertyEnum);
	AddProperty(proxy, "justify", PropertyEnum);
	AddProperty(proxy, "label", PropertyString);
	AddProperty(proxy, "max-width-chars", PropertyInt);
	AddProperty(proxy, "mnemonic-widget", PropertyObject);
	AddProperty(proxy, "selectable", PropertyBool);
	AddProperty(proxy, "single-line-mode", PropertyBool);
	AddProperty(proxy, "use-markup", PropertyBool);
	AddProperty(proxy, "use-underline", PropertyBool);
	AddProperty(proxy, "wrap", PropertyBool);
}

// GtkButtonProxyBase ----------------------------------------------------------

void GtkButtonProxyBase(Proxy * proxy) {
	GtkWidgetProxy(proxy);
	GtkWidgetAddReceivesDefaultProperty(proxy);
	GtkWidgetAddCanFocusProperty(proxy);
	GtkWidgetAddCanDefaultProperty(proxy);
	AddProperty(proxy, "focus-on-click", PropertyBool);
	AddProperty(proxy, "relief", PropertyEnum);
	AddProperty(proxy, "xalign", PropertyFloat);
	AddProperty(proxy, "yalign", PropertyFloat);
}

// GtkButtonProxy --------------------------------------------------------------

void GtkButtonProxy(Proxy * proxy) {
	GtkBinProxy(proxy);
	GtkButtonProxyBase(proxy);
	AddProperty(proxy, "stock-id", PropertyGtkButtonStockId);
	AddProperty(proxy, "label", PropertyString);
	AddProperty(proxy, "image", PropertyObject);
	AddProperty(proxy, "use-underline", PropertyBool);
}

void PropertyGtkButtonStockId(PropertyFuncData * data) {
	const gchar * value= ModelGetString(data->node);
	gtk_button_set_label(GTK_BUTTON(data->object), value);
	gtk_button_set_use_stock(GTK_BUTTON(data->object), TRUE);
}

// GtkToggleButtonProxy --------------------------------------------------------

void GtkToggleButtonProxy(Proxy * proxy) {
	GtkButtonProxy(proxy);
	AddProperty(proxy, "active", PropertyBool);
	AddProperty(proxy, "inconsistent", PropertyBool);
}

// GtkCheckButtonProxy ---------------------------------------------------------

void GtkCheckButtonProxy(Proxy * proxy) {
	GtkToggleButtonProxy(proxy);
	AddProperty(proxy, "draw-indicator", PropertyBool);
}

// GtkRadioButtonProxy ---------------------------------------------------------

void GtkRadioButtonProxy(Proxy * proxy) {
	GtkCheckButtonProxy(proxy);
	AddProperty(proxy, "group", PropertyGtkRadioButtonGroup);
	SetPropertyLazy(proxy, "active", TRUE);
}

void PropertyGtkRadioButtonGroup(PropertyFuncData * data) {
	GObject * object= ModelGetObject(data->loader, data->node, NULL);
	GideonRadioGroup * group= GIDEON_RADIO_GROUP(object);
	GtkRadioButton * button= GTK_RADIO_BUTTON(data->object);
	gtk_radio_button_set_group(button, group->list);
	group->list= gtk_radio_button_get_group(button);
}

// GtkEntryCompletionProxy -----------------------------------------------------

void GtkEntryCompletionProxy(Proxy * proxy) {
	GObjectProxy(proxy);
	AddProperty(proxy, "inline-completion", PropertyBool);
	AddProperty(proxy, "minimum-key-length", PropertyInt);
	AddProperty(proxy, "popup-completion", PropertyBool);
	AddProperty(proxy, "strings", PropertyGtkEntryCompletionStrings);
	AddProperty(proxy, "popup-set-width", PropertyBool);
	AddProperty(proxy, "popup-single-match", PropertyBool);
}

void PropertyGtkEntryCompletionStrings(PropertyFuncData * data) {
	GtkEntryCompletion * completion= GTK_ENTRY_COMPLETION(data->object);
	GtkListStore * model= gtk_list_store_new(1, G_TYPE_STRING);
	GtkTreeIter iter;
	PtrArray * array= ModelGetStringVector(data->node);
	int i;
	for(i= 0; i < array->size; ++i) {
		gtk_list_store_append(model, &iter);
		gtk_list_store_set(model, &iter, 0, array->ptrs[i], -1);		
	}
	gtk_entry_completion_set_model(completion, GTK_TREE_MODEL(model));
	gtk_entry_completion_set_text_column(completion, 0);
	PtrArrayFree(array);
}

// GtkEntryProxy ---------------------------------------------------------------

void GtkEntryProxy(Proxy * proxy) {
	GtkWidgetProxy(proxy);
	GtkWidgetAddCanFocusProperty(proxy);
	GtkWidgetAddEventProperties(proxy);
	AddProperty(proxy, "activates-default", PropertyBool);
	AddProperty(proxy, "editable", PropertyBool);
	AddProperty(proxy, "has-frame", PropertyBool);
	AddProperty(proxy, "invisible-char", PropertyChar);
	AddProperty(proxy, "max-length", PropertyInt);
	AddProperty(proxy, "text", PropertyString);
	AddProperty(proxy, "visibility", PropertyBool);
	AddProperty(proxy, "width-chars", PropertyInt);
	AddProperty(proxy, "xalign", PropertyFloat);
	AddProperty(proxy, "completion", PropertyGtkEntryCompletion);
}

void PropertyGtkEntryCompletion(PropertyFuncData * data) {
	GObject * object= ModelGetObject(data->loader, data->node, NULL);
	gtk_entry_set_completion(GTK_ENTRY(data->object), GTK_ENTRY_COMPLETION(object));
}

// GtkComboBoxProxy ------------------------------------------------------------

void GtkComboBoxProxy(Proxy * proxy) {
	GtkContainerProxyBase(proxy);
	SetCreateInstance(proxy, GtkComboBoxCreate);
	AddProperty(proxy, "add-tearoffs", PropertyBool);
	AddProperty(proxy, "focus-on-click", PropertyBool);
	AddProperty(proxy, "strings", PropertyGtkComboBoxStrings);
	AddProperty(proxy, "active", PropertyInt);
}

GObject * GtkComboBoxCreate(GuiLoader * loader, Node * node) {
	Node * ntext= FindNode(node, "text-mode");
	gboolean text= ntext ? ModelGetBool(ntext) : FALSE;
	if(!text)
		return G_OBJECT(gtk_combo_box_new()); else
		return G_OBJECT(gtk_combo_box_new_text());
}

void PropertyGtkComboBoxStrings(PropertyFuncData * data) {
	GtkComboBox * combo= GTK_COMBO_BOX(data->object);
	PtrArray * array= ModelGetStringVector(data->node);
	int i;
	for(i= 0; i < array->size; ++i)
		gtk_combo_box_append_text(combo, array->ptrs[i]);
	PtrArrayFree(array);
}

// GtkComboBoxEntryProxy -------------------------------------------------------

void GtkComboBoxEntryProxy(Proxy * proxy) {
	GtkComboBoxProxy(proxy);
	SetCreateInstance(proxy, GtkComboBoxEntryCreate);
	AddProperty(proxy, "has-frame", PropertyBool);
	AddProperty(proxy, "text", PropertyGtkComboBoxEntryText);
	AddProperty(proxy, "entry", PropertyGtkComboBoxEntryEntry);
}

GObject * GtkComboBoxEntryCreate(GuiLoader * loader, Node * node) {
	Node * ntext= FindNode(node, "text-mode");
	gboolean text= ntext ? ModelGetBool(ntext) : FALSE;
	if(!text)
		return G_OBJECT(gtk_combo_box_entry_new()); else
		return G_OBJECT(gtk_combo_box_entry_new_text());
}

void PropertyGtkComboBoxEntryText(PropertyFuncData * data) {
	GtkEntry * entry= GTK_ENTRY(gtk_bin_get_child(GTK_BIN(data->object)));
	const gchar * value= ModelGetString(data->node);
	gtk_entry_set_text(entry, value);
}

void PropertyGtkComboBoxEntryEntry(PropertyFuncData * data) {
	GtkEntry * entry= GTK_ENTRY(gtk_bin_get_child(GTK_BIN(data->object)));
	ModelGetObject(data->loader, data->node, G_OBJECT(entry));
}

// GtkSpinButtonProxy ----------------------------------------------------------

void GtkSpinButtonProxy(Proxy * proxy) {
	GtkEntryProxy(proxy);
	AddProperty(proxy, "adjustment", PropertyObject);
	AddProperty(proxy, "climb-rate", PropertyDouble);
	AddProperty(proxy, "digits", PropertyUnsigned);
	AddProperty(proxy, "numeric", PropertyBool);
	AddProperty(proxy, "snap-to-ticks", PropertyBool);
	AddProperty(proxy, "update-policy", PropertyEnum);
	AddProperty(proxy, "value", PropertyDouble);
	AddProperty(proxy, "wrap", PropertyBool);
}

// GtkRangeProxy ---------------------------------------------------------------

void GtkRangeProxy(Proxy * proxy) {
	GtkWidgetProxy(proxy);
	AddProperty(proxy, "inverted", PropertyBool);
	AddProperty(proxy, "update-policy", PropertyEnum);
	AddProperty(proxy, "adjustment", PropertyObject);	
}

// GtkScaleProxy ---------------------------------------------------------------

void GtkScaleProxy(Proxy * proxy) {
	GtkRangeProxy(proxy);
	AddProperty(proxy, "digits", PropertyInt);
	AddProperty(proxy, "draw-value", PropertyBool);
	AddProperty(proxy, "value-pos", PropertyEnum);
	GtkWidgetAddCanFocusProperty(proxy);
}

// GtkProgressBarProxy ---------------------------------------------------------

void GtkProgressBarProxy(Proxy * proxy) {
	GtkWidgetProxy(proxy);
	GtkWidgetAddEventProperties(proxy);
	AddProperty(proxy, "text", PropertyString);
	AddProperty(proxy, "fraction", PropertyDouble);
	AddProperty(proxy, "pulse-step", PropertyDouble);
	AddProperty(proxy, "orientation", PropertyEnum);
	AddProperty(proxy, "ellipsize", PropertyEnum);
}

// GtkImageProxy ---------------------------------------------------------------

void GtkImageProxy(Proxy * proxy) {
	GtkMiscProxy(proxy);
	AddProperty(proxy, "icon-name", PropertyString);
	AddProperty(proxy, "icon-size", PropertyEnum);
	AddProperty(proxy, "pixel-size", PropertyInt);
}

// GtkSeparatorProxy -----------------------------------------------------------

void GtkSeparatorProxy(Proxy * proxy) {
	GtkWidgetProxy(proxy);
}

// GtkSizeGroupProxy -----------------------------------------------------------

void GtkSizeGroupProxy(Proxy * proxy) {
	GObjectProxy(proxy);
	AddProperty(proxy, "mode", PropertyEnum);
	AddProperty(proxy, "ignore-hidden", PropertyBool);
	AddProperty(proxy, "widgets", PropertyGtkSizeGroupWidgets);
}

void PropertyGtkSizeGroupWidgets(PropertyFuncData * data) {
	GtkSizeGroup * group= GTK_SIZE_GROUP(data->object);
	PtrArray * array= ModelGetObjectVector(data->loader, data->node);
	int i;
	for(i= 0; i < array->size; ++i)
		if(array->ptrs[i]) {
			GtkWidget * widget= GTK_WIDGET(array->ptrs[i]);
			gtk_size_group_add_widget(group, widget);
		}
	PtrArrayFree(array);
}

// GtkTextViewProxy ------------------------------------------------------------

void GtkTextViewProxy(Proxy * proxy) {
	GtkContainerProxyBase(proxy);
	GtkWidgetAddCanFocusProperty(proxy);
	GtkWidgetAddEventProperties(proxy);
	AddProperty(proxy, "accepts-tab", PropertyBool);
	AddProperty(proxy, "cursor-visible", PropertyBool);
	AddProperty(proxy, "editable", PropertyBool);
	AddProperty(proxy, "indent", PropertyInt);
	AddProperty(proxy, "justification", PropertyEnum);
	AddProperty(proxy, "left-margin", PropertyInt);
	AddProperty(proxy, "overwrite", PropertyBool);
	AddProperty(proxy, "pixels-above-lines", PropertyInt);
	AddProperty(proxy, "pixels-below-lines", PropertyInt);
	AddProperty(proxy, "pixels-inside-wrap", PropertyInt);
	AddProperty(proxy, "right-margin", PropertyInt);
	AddProperty(proxy, "wrap-mode", PropertyEnum);
	AddProperty(proxy, "text", PropertyGtkTextViewText);
} 

void PropertyGtkTextViewText(PropertyFuncData * data) {
	GtkTextBuffer * buffer= gtk_text_view_get_buffer(GTK_TEXT_VIEW(data->object));
	const gchar * value= ModelGetString(data->node);
	gtk_text_buffer_set_text(buffer, value, -1);
}

// GtkIconViewProxy ------------------------------------------------------------

void GtkIconViewProxy(Proxy * proxy) {
	GtkContainerProxyBase(proxy);
	GtkWidgetAddCanFocusProperty(proxy);
	GtkWidgetAddEventProperties(proxy);
	AddProperty(proxy, "column-spacing", PropertyInt);
	AddProperty(proxy, "columns", PropertyInt);
	AddProperty(proxy, "item-width", PropertyInt);
	AddProperty(proxy, "margin", PropertyInt);
	AddProperty(proxy, "orientation", PropertyEnum);
	AddProperty(proxy, "row-spacing", PropertyInt);
	AddProperty(proxy, "selection-mode", PropertyEnum);
	AddProperty(proxy, "spacing", PropertyInt);
	AddProperty(proxy, "reorderable", PropertyBool);
}

// GtkCellViewProxy ------------------------------------------------------------

void GtkCellViewProxy(Proxy * proxy) {
	GtkWidgetProxy(proxy);
	AddProperty(proxy, "background-set", PropertyBool);
	AddProperty(proxy, "background-gdk", PropertyColor);
}

// GtkTreeViewProxy ------------------------------------------------------------

void GtkTreeViewProxy(Proxy * proxy) {
	GtkContainerProxyBase(proxy);
	GtkWidgetAddCanFocusProperty(proxy);
	GtkWidgetAddEventProperties(proxy);
	AddProperty(proxy, "enable-search", PropertyBool);
	AddProperty(proxy, "fixed-height-mode", PropertyBool);
	AddProperty(proxy, "headers-visible", PropertyBool);
	AddProperty(proxy, "hover-expand", PropertyBool);
	AddProperty(proxy, "hover-selection", PropertyBool);
	AddProperty(proxy, "reorderable", PropertyBool);
	AddProperty(proxy, "rules-hint", PropertyBool);
	AddProperty(proxy, "selection-mode", PropertyGtkTreeViewSelectionMode);
}

void PropertyGtkTreeViewSelectionMode(PropertyFuncData * data) {
	GtkTreeSelection * selection= gtk_tree_view_get_selection(GTK_TREE_VIEW(data->object));
	gint value= ModelGetEnum(data->node);
	gtk_tree_selection_set_mode(selection, value);
}

// GtkColorButtonProxy ---------------------------------------------------------

void GtkColorButtonProxy(Proxy * proxy) {
	GtkContainerProxyBase(proxy);
	GtkButtonProxyBase(proxy);
	AddProperty(proxy, "alpha", PropertyUnsigned);
	AddProperty(proxy, "title", PropertyString);
	AddProperty(proxy, "use-alpha", PropertyBool);
	AddProperty(proxy, "color", PropertyColor);
}

// GtkColorSelectionProxy ------------------------------------------------------

void GtkColorSelectionProxy(Proxy * proxy) {
	GtkContainerProxyBase(proxy);
	AddProperty(proxy, "has-opacity-control", PropertyBool);
	AddProperty(proxy, "has-palette", PropertyBool);
	AddProperty(proxy, "current-alpha", PropertyUnsigned);
	AddProperty(proxy, "current-color", PropertyColor);
}

// GtkFileChooserButtonProxy ---------------------------------------------------

void GtkFileChooserButtonProxy(Proxy * proxy) {
	GtkContainerProxyBase(proxy);
	GtkFileChooserProxyBase(proxy);
	SetCreateInstance(proxy, GtkFileChooserButtonCreate);
	AddProperty(proxy, "title", PropertyString);
	AddProperty(proxy, "width-chars", PropertyInt);
}

GObject * GtkFileChooserButtonCreate(GuiLoader * loader, Node * node) {
	Node * nbackend= FindNode(node, "file-system-backend");
	const gchar * backend= nbackend ? ModelGetString(nbackend) : NULL;
	if(!backend)
		return G_OBJECT(gtk_file_chooser_button_new(NULL, GTK_FILE_CHOOSER_ACTION_OPEN)); else
		return G_OBJECT(gtk_file_chooser_button_new_with_backend(NULL, GTK_FILE_CHOOSER_ACTION_OPEN, backend));
}

// GtkFileChooserWidgetProxy ---------------------------------------------------

void GtkFileChooserWidgetProxy(Proxy * proxy) {
	GtkContainerProxyBase(proxy);
	GtkFileChooserProxyBase(proxy);
	SetCreateInstance(proxy, GtkFileChooserWidgetCreate);
}

GObject * GtkFileChooserWidgetCreate(GuiLoader * loader, Node * node) {
	Node * nbackend= FindNode(node, "file-system-backend");
	const gchar * backend= nbackend ? ModelGetString(nbackend) : NULL;
	if(!backend)
		return G_OBJECT(gtk_file_chooser_widget_new(GTK_FILE_CHOOSER_ACTION_OPEN)); else
		return G_OBJECT(gtk_file_chooser_widget_new_with_backend(GTK_FILE_CHOOSER_ACTION_OPEN, backend));
}

// GtkFontButtonProxy ----------------------------------------------------------

void GtkFontButtonProxy(Proxy * proxy) {
	GtkContainerProxyBase(proxy);
	GtkButtonProxyBase(proxy);
	AddProperty(proxy, "font-name", PropertyString);
	AddProperty(proxy, "show-size", PropertyBool);
	AddProperty(proxy, "show-style", PropertyBool);
	AddProperty(proxy, "title", PropertyString);
	AddProperty(proxy, "use-font", PropertyBool);
	AddProperty(proxy, "use-size", PropertyBool);
}

// GtkFontSelectionProxy -------------------------------------------------------

void GtkFontSelectionProxy(Proxy * proxy) {
	GtkContainerProxyBase(proxy);
}

// GtkFixedProxy ---------------------------------------------------------------

void GtkFixedProxy(Proxy * proxy) {
	GtkContainerProxy(proxy);
	GtkContainerSetChildrenPropertyFunc(proxy, PropertyGtkFixedChildren);
	AddProperty(proxy, "has-window", PropertyBool);
}

void PropertyGtkFixedChildren(PropertyFuncData * data) {
	PtrArray * children= ModelGetObjectVector(data->loader, data->node);
	ContainerFixedSet(GTK_FIXED(data->object), children);
	FreeObjectVector(children);
}

// GtkLayoutProxy --------------------------------------------------------------

void GtkLayoutProxy(Proxy * proxy) {
	GtkContainerProxy(proxy);
	GtkContainerSetChildrenPropertyFunc(proxy, PropertyGtkLayoutChildren);
	AddProperty(proxy, "size", PropertyGtkLayoutSize);
}

void PropertyGtkLayoutChildren(PropertyFuncData * data) {
	PtrArray * children= ModelGetObjectVector(data->loader, data->node);
	ContainerLayoutSet(GTK_LAYOUT(data->object), children);
	FreeObjectVector(children);
}

void PropertyGtkLayoutSize(PropertyFuncData * data) {
	GideonPoint p= ModelGetPoint(data->node);
	gtk_layout_set_size(GTK_LAYOUT(data->object), p.x, p.y);
}

// GtkScrollbarProxy -----------------------------------------------------------

void GtkScrollbarProxy(Proxy * proxy) {
	GtkRangeProxy(proxy);
	GtkWidgetAddCanFocusProperty(proxy);
}

// GtkEventBoxProxy ------------------------------------------------------------

void GtkEventBoxProxy(Proxy * proxy) {
	GtkBinProxy(proxy);
	GtkWidgetAddAppPaintableProperty(proxy);
	GtkWidgetAddEventProperties(proxy);
	AddProperty(proxy, "above-child", PropertyBool);
	AddProperty(proxy, "visible-window", PropertyBool);
}

// GtkDrawingAreaProxy ---------------------------------------------------------

void GtkDrawingAreaProxy(Proxy * proxy) {
	GtkWidgetProxy(proxy);
	GtkWidgetAddEventProperties(proxy);
}

// GtkCalendarProxy ------------------------------------------------------------

void GtkCalendarProxy(Proxy * proxy) {
	GtkWidgetProxy(proxy);
	GtkWidgetAddCanFocusProperty(proxy);
	GtkWidgetAddEventProperties(proxy);
	AddProperty(proxy, "no-month-change", PropertyBool);
	AddProperty(proxy, "show-day-names", PropertyBool);
	AddProperty(proxy, "show-heading", PropertyBool);
	AddProperty(proxy, "show-week-numbers", PropertyBool);
}

// GtkArrowProxy ---------------------------------------------------------------

void GtkArrowProxy(Proxy * proxy) {
	GtkMiscProxy(proxy);
	AddProperty(proxy, "arrow-type", PropertyEnum);
	AddProperty(proxy, "shadow-type", PropertyEnum);
}
